//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "EcatDeviceAPI.h"
#include "Unit_EcatDemo.h"
#include <FileCtrl.hpp>
#include <math.h>
#include <algorithm>
#include "stdio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
        int32_t ret;
        
        //================= {ewBJ ================
        // 1: FB
        if (bInitMotion)
        {
                AnsiString str1;
                char chrData[MAX_PATH];
                uint32_t DrvState;

                for (int i = 0; i < AxisCnt; i++)
                {
                        str1 = ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3];
                        strcpy(chrData, str1.c_str());
                        DrvState = atol(chrData);
                        if (DrvState >= 3 )     
                        {
                                ret = ECAT_McAxisQuickStop(DeviceNo,i);
                        }
                }
        }
        // 2: OPA
        if (bStateOP)
        {
                ret = ECAT_StopDeviceOpTask(DeviceNo);
        }

        // 3: qTާ@
        if (bDevOpen)
	{
		ret = ECAT_CloseDevice(DeviceNo);
	}

}
//---------------------------------------------------------------------------
bool TForm1::timeoutfunc(clock_t startTime, AnsiString strMsg)
{
        AnsiString str1;
	if(emergencystop)
	{
                str1.sprintf("%s stopped: Emergency  Stop", strMsg);
                //ListBox_LogMsg->Items->Add(str1);
                LogMessage(str1);
		return 1;
	}
	clock_t currentTime = clock();
	float timediff_sec = (float)(currentTime-startTime);
	if (timediff_sec > timeout)
	{
                str1.sprintf("%s: User timeout", strMsg);
                //ListBox_LogMsg->Items->Add(str1);
                LogMessage(str1);
		return 1;
	}
	else return 0;
}
//---------------------------------------------------------------------------
void TForm1::LogMessage(AnsiString strMsg)
{
        SYSTEMTIME ft;
        GetLocalTime(&ft);
        AnsiString str1;

        str1.sprintf("%04d/%02d/%02d/%02d:%02d:%02d:  %s", ft.wYear, ft.wMonth, ft.wDay, ft.wHour, ft.wMinute, ft.wSecond, strMsg);
        ListBox_LogMsg->Items->Add(str1);

        ListBox_LogMsg->ItemIndex = ListBox_LogMsg->Items->Count-1;
        ListBox_LogMsg->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        AnsiString str1;

        bDevOpen = false;
        bStateOP = false;
        bInitMotion = false;
        bInitLoop = false;
        ReqLoopCase = 0;
        CurLoopCase = 0;
        AxisCnt=0;
	emergencystop=0;
        SlaveCnt = 0;
        SelSlave = 0;
        nCheckedAxisCnt = 0;
        nLastCheckAxis = 65535;

        TListColumn *pCol=0;
        ListView_SlaveInfo->ViewStyle=vsReport;
        pCol=ListView_SlaveInfo->Columns->Add();
        pCol->Caption="SlaveNo";
        pCol=ListView_SlaveInfo->Columns->Add();
        pCol->Caption="ProductCode";
        pCol=ListView_SlaveInfo->Columns->Add();
        pCol->Caption="VendorID";
        pCol=ListView_SlaveInfo->Columns->Add();
        pCol->Caption="SlaveType";
        ListView_SlaveInfo->Column[0]->Width=ListView_SlaveInfo->Width * 0.2;
        ListView_SlaveInfo->Column[1]->Width=ListView_SlaveInfo->Width * 0.3;
        ListView_SlaveInfo->Column[2]->Width=ListView_SlaveInfo->Width * 0.25;
        ListView_SlaveInfo->Column[3]->Width=ListView_SlaveInfo->Width * 0.25;

        ListView_AxisInfo->ViewStyle=vsReport;
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="AxisNo";
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="CmdPosition";
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="Position";
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="Velocity";
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="AxisState";
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="AxisError";
        pCol=ListView_AxisInfo->Columns->Add();
        pCol->Caption="DriverError";
        ListView_AxisInfo->Column[0]->Width=ListView_AxisInfo->Width * 0.1;
        ListView_AxisInfo->Column[1]->Width=ListView_AxisInfo->Width * 0.15;
        ListView_AxisInfo->Column[2]->Width=ListView_AxisInfo->Width * 0.15;
        ListView_AxisInfo->Column[3]->Width=ListView_AxisInfo->Width * 0.15;
        ListView_AxisInfo->Column[4]->Width=ListView_AxisInfo->Width * 0.15;
        ListView_AxisInfo->Column[5]->Width=ListView_AxisInfo->Width * 0.15;
        ListView_AxisInfo->Column[6]->Width=ListView_AxisInfo->Width * 0.15;

        Edit_Position->Text = "1";
        Edit_Velocity->Text = "1";
        Edit_HomeMethod->Text = "1";
        Edit_SoftLimitMax->Text = "100";
        Edit_SoftLimitMin->Text = "-100";

        ListView_GroupInfo->ViewStyle=vsReport;
        pCol=ListView_GroupInfo->Columns->Add();
        pCol->Caption="GroupNo";
        pCol=ListView_GroupInfo->Columns->Add();
        pCol->Caption="GroupState";
        pCol=ListView_GroupInfo->Columns->Add();
        pCol->Caption="CmdBuffer";
        pCol=ListView_GroupInfo->Columns->Add();
        pCol->Caption="AxisNo";
        ListView_GroupInfo->Column[0]->Width=ListView_GroupInfo->Width * 0.2;
        ListView_GroupInfo->Column[1]->Width=ListView_GroupInfo->Width * 0.25;
        ListView_GroupInfo->Column[2]->Width=ListView_GroupInfo->Width * 0.25;
        ListView_GroupInfo->Column[3]->Width=ListView_GroupInfo->Width * 0.3;

        TListItem *pItem=0;
        for (uint16_t i = 0; i < MC_GROUP_NO_MAX; i++)
        {
                pItem=ListView_GroupInfo->Items->Add();
                pItem->Caption=String(i);        // GroupNo
                pItem->SubItems->Add("");        // GroupState
                pItem->SubItems->Add("");        // CmdBuffer
                pItem->SubItems->Add("");        // AxisNo
        }

        Edit_GpLineVel->Text = "1";
        Edit_GpLinePos->Text = "1";
        Edit_GpLineTime->Text = "5";

        Edit_GpVelocity->Text = "1";
        Edit_GpCenterPos->Text = "0,0,0";
        Edit_GpNvPos->Text = "10,0,0";
        Edit_GpEndPos->Text = "0,0,10";
        Edit_GpAngle->Text = "90";
        Edit_GpPitch->Text = "10";
        Edit_GpEndRad->Text = "10";

        Edit_GpVelocity->Enabled = true;
        Edit_GpCenterPos->Enabled = true;
        Edit_GpNvPos->Enabled = false;
        Edit_GpEndPos->Enabled = false;
        Edit_GpAngle->Enabled = true;
        Edit_GpPitch->Enabled = false;
        Edit_GpEndRad->Enabled = false;

        ComboBox_GpMvMode->Items->Add("CircAbs");
        ComboBox_GpMvMode->Items->Add("CircAbs_CP_Ang");
        ComboBox_GpMvMode->Items->Add("CircAbs_CP_EP");
        ComboBox_GpMvMode->Items->Add("CircAbs_BP_EP");
        ComboBox_GpMvMode->Items->Add("3DCircAbs_CP_Ang");
        ComboBox_GpMvMode->Items->Add("3DCircAbs_CP_EP");
        ComboBox_GpMvMode->Items->Add("3DCircAbs_BP_EP");
        ComboBox_GpMvMode->Items->Add("CircRel");
        ComboBox_GpMvMode->Items->Add("CircRel_CP_Ang");
        ComboBox_GpMvMode->Items->Add("CircRel_CP_EP");
        ComboBox_GpMvMode->Items->Add("CircRel_BP_EP");
        ComboBox_GpMvMode->Items->Add("3DCircRel_CP_Ang");
        ComboBox_GpMvMode->Items->Add("3DCircRel_CP_EP");
        ComboBox_GpMvMode->Items->Add("3DCircRel_BP_EP");
        ComboBox_GpMvMode->Items->Add("HelicAbs");
        ComboBox_GpMvMode->Items->Add("3DHelicAbs_CP_Ang");
        ComboBox_GpMvMode->Items->Add("HelicRel");
        ComboBox_GpMvMode->Items->Add("3DHelicRel_CP_Ang");
        ComboBox_GpMvMode->Items->Add("ConicHelixAbs");
        ComboBox_GpMvMode->Items->Add("3DConicHelixAbs_CP_Ang");
        ComboBox_GpMvMode->Items->Add("ConicHelixRel");
        ComboBox_GpMvMode->Items->Add("3DConicHelixRel_CP_Ang");
        ComboBox_GpMvMode->ItemIndex=0;

        Button_Start->Enabled = false;
        WidgetEnabledByRunMode(DEV_RM_IS_CLOSE);

        mRecordCase = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_ScanDevClick(TObject *Sender)
{
        int32_t ret;
	uint16_t DeviceCnt;
	uint8_t CardId[CARD_DEVICE_NO_MAX];

	AnsiString str1;
	uint16_t dccl;
	ret = ECAT_GetDeviceCnt(&DeviceCnt,CardId);
	if(ret < 0)
	{
                str1.sprintf("Failed to init device:%d", ret);
		ListBox_LogMsg->Items->Add(str1);
	}else{
                ComboBox_Dev->Items->Clear();
		for(int i=0;i<DeviceCnt;i++)
		{
                        str1.sprintf("%u", CardId[i]);
                        ComboBox_Dev->Items->Add(str1);
		}
                ComboBox_Dev->ItemIndex = 0;
                Button_Start->Enabled = true;
                DeviceNo = CardId[0];
	}

//        char charTemp[MAX_PATH];
        char charTemp[1024];
        uint16_t charSize = 0;
        ECAT_GetDllVersion(charTemp, &charSize);
        str1 = charTemp;
        str1 = "Dll Version is " + str1;
        LogMessage(str1);
        ECAT_GetFirmwareVersion(DeviceNo, charTemp, &charSize);
        str1 = charTemp;
        str1 = "Firmware Version is " + str1;
        LogMessage(str1);
}
//---------------------------------------------------------------------------

int32_t TForm1::SetAxisParam(uint16_t AxisNo)
{
	AnsiString str1;
	int32_t ret = 0;
        /*
        These parameters have been set in ECAT_McInit_Ex
        
	ret = ECAT_McSetAxisPPU(DeviceNo,AxisNo,AxisInitParam.PPU[AxisNo]);
	if(ret < 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set axis PPU:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}

	ret = ECAT_McSetAxisHomeMethod(DeviceNo,AxisNo,AxisInitParam.HomeMethod[AxisNo]);
	if(ret < 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set axis home method:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}

	ret = ECAT_McSetAxisHomeSpeed(DeviceNo,AxisNo,AxisInitParam.HomeSpeedSeachSw[AxisNo],AxisInitParam.HomeSpeedSeachZr[AxisNo]);
	if(ret < 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set axis home speed:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}

	ret = ECAT_McSetAxisHomeAcc(DeviceNo,AxisNo,AxisInitParam.HomeAcc[AxisNo]);
	if(ret < 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set axis home acc:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}

	ret = ECAT_McSetAxisEncoderPPR(DeviceNo,AxisNo,AxisInitParam.EncoderPPR[AxisNo]);
	if(ret != 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set encoder PPR:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}

	ret = ECAT_McSetAxisMotorPPR(DeviceNo,AxisNo,AxisInitParam.MotorPPR[AxisNo]);
	if(ret != 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set motor PPR:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}


        */

        ret = ECAT_McSetAxisAccDecUnit(DeviceNo, AxisNo, MC_ACC_DEC_MODE_TIME);
	if(ret != 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set motor Acc unit:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}
        ret = ECAT_McSetAxisAccTime(DeviceNo, AxisNo, 100);//ms
	if(ret != 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set motor AccTime:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}
        /*
        *the other method to set acc
        ret = ECAT_McSetAxisAccDecUnit(DeviceNo, AxisNo, MC_ACC_DEC_MODE_RATE);
	if(ret != 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set motor Acc unit:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}
        ret = ECAT_McSetAxisAccDecRate(DeviceNo, AxisNo, 10000);//user unit /S^2
	if(ret != 0)
	{
                str1.sprintf("AxisNo[%d]:Failed to set motor AccTime:%d",AxisNo,ret);
                LogMessage(str1);
		return ret;
	}
        */
	return 0;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        int32_t ret;
        uint32_t i,j;
        AnsiString StrAlState, str1;
        uint32_t LinkUp,SlavesResp,AlStates,Wc;
        uint8_t BitValue;
        uint16_t AxisNo,u16Value,GrpNo;
        double dValue;
        uint32_t u32Value,BitDI;
        int32_t i32Value;
        axis_di_t	AxisDI;
        uint16_t SlaveNo;

        uint16_t Alias;
        uint32_t ProductCode,VendorID,RevisionNo,SerialNo,SlaveType;
        uint8_t  AlState;
        uint32_t GpState[4];
        char SlaveName[MAX_PATH];

        //static double timercount=0;
        //str1.sprintf("%.3f",timercount);
        //timercount+=0.025;
        //WgLbltimer.SetWindowText(str1);


        /*static clock_t time1,time2;
        time1= clock();
        clock_t timediff = time1-time2;
        time2= clock();
        float timediff_sec = (((float)timediff) / CLOCKS_PER_SEC);
        str1.sprintf("%.3f",timediff_sec);*/

        ret = ECAT_GetDeviceStateEx(DeviceNo,&LinkUp,&SlavesResp,&AlStates,&Wc);

        if(ret == 0)
        {
                str1.sprintf("Slave(s):%d",SlavesResp);
                Edit_SlavesResp->Text = str1;
                if(AlStates == 0)
                {
                        StrAlState = "INIT";
                }
                else if(AlStates == 0x02)
                {
                        StrAlState = "PREOP";
                }
                else if(AlStates == 0x04)
                {
                        StrAlState = "SAFEOP";
                }
                else if(AlStates == 0x08)
                {
                        StrAlState = "OP";
				
                }
                else
                {
                        StrAlState = "Unknown";
                        str1.sprintf("Unknown  WC:%d",Wc);
                        LogMessage(str1);

                }

                Edit_ReqState->Text = StrAlState;
                str1.sprintf("WC:%d",Wc);
                Edit_Wc->Text = str1;

                if(LinkUp)
                {
                        //WgLblLinkUp.SetWindowText(_T("Up"));
                }
                else
                {
                        //WgLblLinkUp.SetWindowText(_T("Down"));
                        //SlaveCnt = 0;
                }
        }
        if( (DevRunMode == DEV_RM_IS_OP_TASK))
        {

                if(StrAlState=="SAFEOP" || StrAlState=="Unknown" || SlaveCnt != SlavesResp)
                {
                        for(i=0;i<SlaveCnt;i++)
                        {
                                ret=ECAT_GetSlaveInfo(DeviceNo,i,&Alias,&ProductCode,&VendorID,&RevisionNo
                                        ,&SerialNo,&AlState,&SlaveType, SlaveName);
                                if(ret!=0)
                                        str1.sprintf("!%d",i);
                                else if(AlState!=0x08)
                                        str1.sprintf("!%d",i);
                                else
                                        str1.sprintf("%d",i);

                                ListView_SlaveInfo->Items->Item[i]->SubItems->Strings[0] = str1;

                        }
                }
        }
        else if((DevRunMode == DEV_RM_IS_OPEN))
        {
                if( (SlaveCnt != SlavesResp))
                {
                        ListView_SlaveInfo->Items->Clear();
                        TListItem *pItem=0;
                        for(i=0;i<SlavesResp;i++)
                        {
                                ret=ECAT_GetSlaveInfo(DeviceNo,i,&Alias,&ProductCode,&VendorID,&RevisionNo
						,&SerialNo,&AlState,&SlaveType, SlaveName);
                                pItem=ListView_SlaveInfo->Items->Add();

                                pItem->Caption=String(i);        // SlaveNo
                                str1.sprintf("%lu", ProductCode);
                                pItem->SubItems->Add(str1);        // Product Code
                                str1.sprintf("%lu", VendorID);
                                pItem->SubItems->Add(str1);        // Vendor ID
                                str1.sprintf("%lu", SlaveType);
                                pItem->SubItems->Add(str1);        // Slave Type
                        }
                        SlaveCnt = SlavesResp;
                }
        }
        if((bInitMotion) && (DevRunMode == DEV_RM_IS_OP_TASK))
        {
                double dValue32[MC_AXIS_NO_MAX];
                uint32_t u32Value32[MC_AXIS_NO_MAX];
                int32_t i32Value32[MC_AXIS_NO_MAX];
                uint16_t u16Value32[MC_AXIS_NO_MAX];
                axis_di_t	AxisDI32;

                ret = ECAT_McGetAxisCommandPos_Ex(DeviceNo,65535,dValue32);
                if(ret == 0)
                {
                        for(i=0;i< (uint32_t)AxisCnt;i++)
                        {
                                str1.sprintf("%.3f",dValue32[i]);
                                ListView_AxisInfo->Items->Item[i]->SubItems->Strings[0] = str1;
                        }
                }

                ret = ECAT_McGetAxisActualPos_Ex(DeviceNo,65535,dValue32);
                if(ret == 0)
                {
                        for(i=0;i<(uint32_t)AxisCnt;i++)
                        {
                                str1.sprintf("%.3f",dValue32[i]);
                                ListView_AxisInfo->Items->Item[i]->SubItems->Strings[1] = str1;
                        }
                }

                ret = ECAT_McGetAxisActualVel_Ex(DeviceNo,65535,dValue32);
                if(ret == 0)
                {
                        for(i=0;i<(uint32_t)AxisCnt;i++)
                        {
                                str1.sprintf("%.1f",dValue32[i]);
                                ListView_AxisInfo->Items->Item[i]->SubItems->Strings[2] = str1;
                        }
                }

                ret = ECAT_McGetAxisState_Ex(DeviceNo,65535,u32Value32);
                if(ret == 0)
                {
                        for(i=0;i<(uint32_t)AxisCnt;i++)
                        {                                     
                                ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] = GetAxisStateStr(u32Value32[i]);
                        }
                }

                ret = ECAT_McGetAxisLastError_Ex(DeviceNo,65535,i32Value32);
                if(ret == 0)
                {
                        for(i=0;i<(uint32_t)AxisCnt;i++)
                        {
                                str1.sprintf("%d",i32Value32[i]);
                                ListView_AxisInfo->Items->Item[i]->SubItems->Strings[4] = str1;
                        }
                }

                ret = ECAT_McGetAxisDriveError_Ex(DeviceNo,65535,u16Value32);
                if(ret == 0)
                {
                        for(i=0;i<(uint32_t)AxisCnt;i++)
                        {
                                str1.sprintf("%u",u16Value32[i]);
                                ListView_AxisInfo->Items->Item[i]->SubItems->Strings[5] = str1;
                        }
                }

                for(i=0;i<MC_GROUP_NO_MAX;i++)
                {
                        GrpNo = i;

                        ret = ECAT_McGetGroupState(DeviceNo,GrpNo,&u32Value);
                        if(ret == 0)
                        {
                                ListView_GroupInfo->Items->Item[i]->SubItems->Strings[0] = GetGrpStateStr(u32Value);

                                //=============== for 3f plot in Matlab ===============
                                if (i == 0 && mRecordCase > 0)
                                {
                                        if (u32Value == MC_GS_MOVING)
                                        {
                                                mRecordCase = 2;        // record
                                                str1.sprintf("%s, ", ListView_AxisInfo->Items->Item[0]->SubItems->Strings[1]);
                                                strPosX += str1;
                                                str1.sprintf("%s, ", ListView_AxisInfo->Items->Item[1]->SubItems->Strings[1]);
                                                strPosY += str1;
                                                str1.sprintf("%s, ", ListView_AxisInfo->Items->Item[2]->SubItems->Strings[1]);
                                                strPosZ += str1;
                                        }
                                        else if (u32Value == MC_GS_STANDBY) // stop and print
                                        {
                                                if (mRecordCase == 2)
                                                {
                                                        str1.sprintf("%s", ListView_AxisInfo->Items->Item[0]->SubItems->Strings[1]);
                                                        strPosX += str1;
                                                        str1.sprintf("%s", ListView_AxisInfo->Items->Item[1]->SubItems->Strings[1]);
                                                        strPosY += str1;
                                                        str1.sprintf("%s", ListView_AxisInfo->Items->Item[2]->SubItems->Strings[1]);
                                                        strPosZ += str1;

                                                        mRecordCase = 0;

                                                        FILE * fp;
                                                        /* ɮ׫ */

                                                        fp = fopen("D:\\3DCurvePath.txt","w");
                                                        /* إɮ */

                                                        fprintf(fp,"X= [%s];\n",strPosX);
                                                        fprintf(fp,"Y= [%s];\n",strPosY);
                                                        fprintf(fp,"Z= [%s];\n",strPosZ);
                                                        /* gJ */

                                                        //fscanf(fp,"%s",&Buffer);
                                                        /* Ū */

                                                        fclose(fp);                                    
                                                        /* s */
                                                }
                                        }
                                }
                                //=====================================================
                        }

                        ret = ECAT_McGetGroupCmdBuffer(DeviceNo,GrpNo,&u16Value);
                        if(ret == 0)
                        {
                                str1.sprintf("%u",u16Value);
                                ListView_GroupInfo->Items->Item[i]->SubItems->Strings[1] = str1;
                        }

                        if (bInitLoop)
                        {
                                GpState[i] = u32Value;
                        }
                }
        }

        if (bInitLoop)
        {
                double Pos[MC_AXIS_NO_MAX];
	        double Vel,Ang,Pitch;

                switch (CurLoopCase)
                {
                        case 0: // none
                                break;
                        case 1: // All Axes go to position zero
                                Vel = 3;
                                memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 0, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);

                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 0, 5);
                                }

                                LogMessage("Loop1 test 0: Move to position zero");
                                CurLoopCase = 99;
                                ReqLoopCase = 2;
                                break;
                        case 2:
                                Pos[0] = 0.0;
                                Pos[1] = 20.0;
                                Ang = 720;
                                Pitch = 10;
                                Vel = 3;
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 0, Ang, Pos, Pitch, Vel);
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 1, Ang, Pos, Pitch, Vel);
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 2, Ang, Pos, Pitch, Vel);
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 3, Ang, Pos, Pitch, Vel);

                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 250, 5);
                                }

                                LogMessage("Loop1 test 1: HelicalAbs(+) & LineAbs(+)");
                                CurLoopCase = 99;
                                ReqLoopCase = 3;
                                break;
                        case 3:
                                Pos[0] = 100.0;
                                Pos[1] = 100.0;
                                Pos[2] = 120.0;
                                Vel = 5;
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 0, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //for (int i = 0; i<(AxisCnt-3); i++)
                                //        Pos[i] = 300.0;
                                //Vel = 20;
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 500, 5);
                                }
                                LogMessage("Loop1 test 2: LineAbs(+) & LineAbs(+) ");
                                CurLoopCase = 99;
                                ReqLoopCase = 4;
                                break;
                        case 4:
                                Pos[0] = 0.0;
                                Pos[1] = 0.0;
                                Pos[2] = 20.0;
                                Vel = 5;
                                ECAT_McGroupMoveLineAbs(DeviceNo, 0, Pos, Vel);
                                ECAT_McGroupMoveLineAbs(DeviceNo, 1, Pos, Vel);
                                ECAT_McGroupMoveLineAbs(DeviceNo, 2, Pos, Vel);
                                ECAT_McGroupMoveLineAbs(DeviceNo, 3, Pos, Vel);

                                //for (int i = 0; i<(AxisCnt-3); i++)
                                //        Pos[i] = 150.0;
                                //Vel = 20;
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 250, 5);
                                }
                                LogMessage("Loop1 test 3: LineAbs(-) & LineAbs(-) ");
                                CurLoopCase = 99;
                                ReqLoopCase = 5;
                                break;
                        case 5:
                                Pos[0] = 0.0;
                                Pos[1] = 20.0;
                                Ang = -720;
                                Pitch = 10;
                                Vel = 3;
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 0, Ang, Pos, Pitch, Vel);
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 1, Ang, Pos, Pitch, Vel);
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 2, Ang, Pos, Pitch, Vel);
                                ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, 3, Ang, Pos, Pitch, Vel);
                                //memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
                                //Vel = 20;
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 0, 5);
                                }
                                LogMessage("Loop1 test 4: HelicalAbs(-) & LineAbs(-)");
                                CurLoopCase = 99;
                                ReqLoopCase = 2;
                                break;
                        case 11:// All Axes go to position zero
                                Vel = 10;
                                memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 0, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 0, 5);
                                }

                                LogMessage("Loop2 test 0: Move to position zero");
                                CurLoopCase = 99;
                                ReqLoopCase = 12;
                                break;
                        case 12:
                                Pos[0] = 0.0;
                                Pos[1] = 10.0;
                                Pos[2] = 0.0;
                                Pos[3] = 0.7071;
                                Pos[4] = 0.7071;
                                Pos[5] = 0.0;
                                Vel = 3;
                                Ang = 720;
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 0, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 1, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 2, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 3, Vel, Ang, &Pos[0], &Pos[3]);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 250, 5);
                                }

                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //SetAxisMoveAbs(AxisCnt-1, Pos[0], Vel);

                                LogMessage("Loop2 test 1: 3DCircularAbs_CP_Angle(+) & LineAbs(+)");
                                CurLoopCase = 99;
                                ReqLoopCase = 13;
                                break;
                        case 13:
                                Pos[0] = 0.0;
                                Pos[1] = 10.0;
                                Pos[2] = 0.0;
                                Pos[3] = 0.7071;
                                Pos[4] = 0.7071;
                                Pos[5] = 0.0;
                                Vel = 3;
                                Ang = -720;
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 0, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 1, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 2, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, 3, Vel, Ang, &Pos[0], &Pos[3]);
                                //memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //SetAxisMoveAbs(AxisCnt-1, Pos[0], Vel);

                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 0, 5);
                                }

                                LogMessage("Loop2 test 2: 3DCircularAbs_CP_Angle(-) & LineAbs(-)");
                                CurLoopCase = 99;
                                ReqLoopCase = 14;
                                break;
                        case 14:
                                Pos[0] = 0.0;
                                Pos[1] = 10.0;
                                Pos[2] = 0.0;
                                Pos[3] = 0.7071;
                                Pos[4] = 0.7071;
                                Pos[5] = 0.0;
                                Vel = 3;
                                Ang = 720;
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 0, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 1, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 2, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 3, Vel, Ang, &Pos[0], &Pos[3]);
                                //for (int i = 0; i<(AxisCnt-9); i++)
                                //        Pos[i] = 200.0;
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //SetAxisMoveAbs(AxisCnt-1, Pos[0], Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 250, 5);
                                }

                                LogMessage("Loop2 test 3: 3DCircularRel_CP_Angle(+) & LineAbs(+)");
                                CurLoopCase = 99;
                                ReqLoopCase = 15;
                                break;
                        case 15:
                                Pos[0] = 0.0;
                                Pos[1] = 10.0;
                                Pos[2] = 0.0;
                                Pos[3] = 0.7071;
                                Pos[4] = 0.7071;
                                Pos[5] = 0.0;
                                Vel = 3;
                                Ang = -720;
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 0, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 1, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 2, Vel, Ang, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, 3, Vel, Ang, &Pos[0], &Pos[3]);
                                //memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //SetAxisMoveAbs(AxisCnt-1, Pos[0], Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 0, 5);
                                }

                                LogMessage("Loop2 test 4: 3DCircularRel_CP_Angle(-) & LineAbs(-)");
                                CurLoopCase = 99;
                                ReqLoopCase = 16;
                                break;
                        case 16:
                                Pos[0] = 0.0;
                                Pos[1] = 10.0;
                                Pos[2] = 0.0;
                                Pos[3] = 0.7071;
                                Pos[4] = 0.7071;
                                Pos[5] = 0.0;
                                Vel = 3;
                                Ang = 720;
                                Pitch = 10;
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 0, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 1, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 2, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 3, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                //for (int i = 0; i<(AxisCnt-9); i++)
                                //        Pos[i] = 200.0;
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //SetAxisMoveAbs(AxisCnt-1, Pos[0], Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 250, 5);
                                }

                                LogMessage("Loop2 test 5: 3DHelicalAbs_CP_Angle(+) & LineAbs(+)");
                                CurLoopCase = 99;
                                ReqLoopCase = 17;
                                break;
                        case 17:
                                Pos[0] = 0.0;
                                Pos[1] = 10.0;
                                Pos[2] = 0.0;
                                Pos[3] = 0.7071;
                                Pos[4] = 0.7071;
                                Pos[5] = 0.0;
                                Vel = 3;
                                Ang = -720;
                                Pitch = 10;
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 0, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 1, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 2, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, 3, Vel, Ang, Pitch, &Pos[0], &Pos[3]);
                                //memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 1, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 2, Pos, Vel);
                                //ECAT_McGroupMoveLineAbs_Ex(DeviceNo, 3, Pos, Vel);
                                //SetAxisMoveAbs(AxisCnt-1, Pos[0], Vel);
                                for (int i = 12; i< AxisCnt; i++)
                                {
                                        if (ListView_AxisInfo->Items->Item[i]->SubItems->Strings[3] == "StandStill")
                                                SetAxisMoveAbs(i, 0, 5);
                                }

                                LogMessage("Loop2 test 6: 3DCircularRel_CP_Angle(-) & LineAbs(-)");
                                CurLoopCase = 99;
                                ReqLoopCase = 12;
                                break;
                        case 99:
                                LoopWaitCnt = 0;
                                CurLoopCase = 100;
                                break;
                        case 100:       // wait for command to finish
                                if (LoopWaitCnt < 50)
                                        LoopWaitCnt++;
                                else if ( (GpState[0] == MC_GS_STANDBY)
                                        &&(GpState[1] == MC_GS_STANDBY)
                                        &&(GpState[2] <= MC_GS_STANDBY)
                                        &&(GpState[3] <= MC_GS_STANDBY) )
                                        {
                                                if (LoopWaitCnt < (50+(int)(5*1000/TimerInterval)))  // wait for 5 sec
                                                                LoopWaitCnt++;

                                                CurLoopCase = ReqLoopCase;
                                        }
                                break;
                        case 101:       // stop
                                for (int i = 0; i< MC_GROUP_NO_MAX; i++)
                                {
                                        if (GpState[i] != MC_GS_STANDBY)
                                                ECAT_McGroupStop(DeviceNo, i);
                                }
                                for (int i = 12; i< AxisCnt; i++)
                                        ECAT_McAxisStop(DeviceNo,i);
                                CurLoopCase = 0;
                                ReqLoopCase = 0;
                                break;
                }
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_StartClick(TObject *Sender)
{

        int32_t ret;
	AnsiString str1;
        char chrData[MAX_PATH];

        int iFileHandle;
        int iFileLength;
        int iBytesRead;
        int iByteRemain;
        char *pszBuffer;
        char SlaveName[MAX_PATH];

        //uint16_t NetworkInfoNo = 0;     // set 0 as default in this demo
	//uint32_t Offset = 0;
       	uint8_t LastFlag;

        uint16_t Alias;
        uint32_t ProductCode,VendorID,RevisionNo,SerialNo,SlaveType;
        uint32_t LinkUp,SlavesResp,AlStates,Wc;
        uint8_t  AlState;


	if(!bDevOpen)
	{
                //============ Step1: Open device =============//
		str1= ComboBox_Dev->Text;
                strcpy(chrData, str1.c_str());
                DeviceNo = (uint16_t)atol(chrData);


		ret = ECAT_OpenDevice(DeviceNo);


		if(ret < 0)
		{
                        str1.sprintf("Failed to open EcatDevice:%d", ret);
                        ListBox_LogMsg->Items->Add(str1);
			WidgetEnabledByRunMode(DEV_RM_IS_CLOSE);
			return;
		}
		else
		{
			WidgetEnabledByRunMode(DEV_RM_IS_OPEN);
                        ECAT_StopDeviceOpTask(DeviceNo);
		        for (int i = 0; i < 10; i++)
		        {
			        ret = ECAT_GetDeviceStateEx(DeviceNo, &LinkUp, &SlavesResp, &AlStates, &Wc);
			        if (ret == 0 && AlStates == ECAT_AS_PREOP)
			        	break;
		        	Sleep(1000);
	        	}
		        if (ret != 0 || AlStates != ECAT_AS_PREOP)
	        	{
	        		str1.sprintf("ECAT_StopDeviceOpTask failed");
                                ListBox_LogMsg->Items->Add(str1);
			        WidgetEnabledByRunMode(DEV_RM_IS_CLOSE);
			        return;
	        	}
                      	ret = ECAT_SetSlaveNoType(DeviceNo, SLAVE_NO_TYPE_POSITION);
	        	if (ret != 0)
		        {
	        		str1.sprintf("Set SlaveNo Type failed");
                                ListBox_LogMsg->Items->Add(str1);
			        WidgetEnabledByRunMode(DEV_RM_IS_CLOSE);
			        return;
	               	}
                }

                //============ Step3: Set state to OP=============//
                if(!bStateOP)
                {

                        uint16_t NetworkInfoNo = 0;     // set 0 as default in this demo
                        //uint8_t EnumCycleTime = DEV_OP_CYCLE_TIME_0_5MS;
                        uint8_t EnumCycleTime = DEV_OP_CYCLE_TIME_1MS;
                        uint32_t WcErrCnt=3;
                        uint16_t RetryCnt = 0;
                        ret = ECAT_GetDeviceStateEx(DeviceNo,&LinkUp,&SlavesResp,&AlStates,&Wc);
                        SlaveCnt=SlavesResp;

                        ListView_SlaveInfo->Items->Clear();
                        TListItem *pItem=0;
                        for (uint32_t i = 0; i < SlaveCnt; i++)
                        {
                                ret=ECAT_GetSlaveInfo(DeviceNo,i,&Alias,&ProductCode,&VendorID,&RevisionNo
                                                        ,&SerialNo,&AlState,&SlaveType, SlaveName);
                                pItem=ListView_SlaveInfo->Items->Add();

                                pItem->Caption=String(i);        // SlaveNo
                                str1.sprintf("%lu", ProductCode);
                                LogMessage(str1);
                                pItem->SubItems->Add(str1);        // Product Code
                                str1.sprintf("%lu", VendorID);
                                pItem->SubItems->Add(str1);        // Vendor ID
                                str1.sprintf("%lu", SlaveType);
                                pItem->SubItems->Add(str1);        // Slave Type
                        }
                       	ret = ECAT_SetSlaveNoType(DeviceNo, SLAVE_NO_TYPE_ALIAS_ID);
	        	if (ret != 0)
		        {
	        		str1.sprintf("Set SlaveNo Type failed");
                                ListBox_LogMsg->Items->Add(str1);
			        WidgetEnabledByRunMode(DEV_RM_IS_CLOSE);
			        return;
	               	}

                        ret = -1;

                        for(int i = 0; i < 10; i++)
                        {
                                ret = ECAT_StartDeviceOpTask(DeviceNo,NetworkInfoNo,EnumCycleTime,WcErrCnt);
                                if(ret == 0) break;
                                Sleep(100);
                        }
                        if(ret < 0)
                        {
                                str1.sprintf("DeviceNo(%d),NetworkInfoNo(%d),EnumCycleTime(%d),WcErrCnt(%d)", DeviceNo,NetworkInfoNo,EnumCycleTime,WcErrCnt);
                                LogMessage(str1);
                                str1.sprintf("Failed to start device op task:%d, retry times:%d", ret, RetryCnt);
                                LogMessage(str1);
                                WidgetEnabledByRunMode(DEV_RM_IS_OPEN);
                                return;
                        }
                        else
                        {
                                str1.sprintf("Start device op success");
                                LogMessage(str1);
                        }
                        WidgetEnabledByRunMode(DEV_RM_IS_OP_TASK);


                        //========= T{AiJOP~iJU@q: ]mbѼ ========//

                        //uint32_t LinkUp,SlavesResp,AlStates = 0,Wc;
                        clock_t Time1=clock();

                        float timediff_sec;
                        do
                        {
                                ret = ECAT_GetDeviceStateEx(DeviceNo,&LinkUp,&SlavesResp,&AlStates,&Wc);

                                clock_t Time2 = clock();
                                timediff_sec = (float)(Time2-Time1);
                                if (timediff_sec > timeout_OP) // 5OPN
                                {
                                        str1 = "Set State to OP timeout!";
                                        LogMessage(str1);

                                        ECAT_StopDeviceOpTask(DeviceNo);
                                        WidgetEnabledByRunMode(DEV_RM_IS_OPEN);
                                        Button_Start->Caption = "Start";
                                        bStateOP = false;
                                        return;
                                }
                                Sleep(100);
                        }while (AlStates != 0x08);

                        str1.sprintf("Set state to OP take %.02f second!", timediff_sec);
                        LogMessage(str1);
                }
                else
                {
                        ret = ECAT_StopDeviceOpTask(DeviceNo);

                        if(ret < 0)
                        {
                                str1.sprintf("Failed to stop device op task:%d", ret);
                                LogMessage(str1);
                                WidgetEnabledByRunMode(DEV_RM_IS_OP_TASK);
                        }
                        else
                        {
                                WidgetEnabledByRunMode(DEV_RM_IS_OPEN);
                        }                        
                }
                              
                //============ Step4: Config Motion =============//
                if (!bInitMotion)
                {
                        AnsiString str1;
                        int32_t ret = 0;
                        int i;

                        uint16_t McSlaveNo[MC_AXIS_NO_MAX];
                        uint16_t McSubAxisNo[MC_AXIS_NO_MAX];

                        //================= init motion parameters to card ====================//

                        ret = ECAT_McInit_Ex(DeviceNo, "Auto.motcfg", McSlaveNo,McSubAxisNo, &AxisCnt);
                        if(ret < 0)
                        {
                                str1.sprintf("Failed to initialize axes:%d", ret);
                                LogMessage(str1);
                                if(ret == -1027)
                                {
                                        str1.sprintf("Please use ECAT_Utility.exe to create Motion Control Parameter File(.motcfg)");
                                        LogMessage(str1);
                                }
                                return;
                        }
			ListView_AxisInfo->Items->Clear();
			TListItem *pItem=0;
                        for(i=0;i<AxisCnt;i++)
                        {
				pItem=ListView_AxisInfo->Items->Add();
                                pItem->Caption=String(i);        // AxisNo
                                pItem->SubItems->Add("");        // CmdPosition
                                pItem->SubItems->Add("");        // Position
                                pItem->SubItems->Add("");        // Velocity
                                pItem->SubItems->Add("");        // AxisState
                                pItem->SubItems->Add("");        // AxisError
                                pItem->SubItems->Add("");        // DriverError
                                ret = SetAxisParam(i);
                                if(ret < 0)
                                {
                                        return;
                                }
                        }

                        bInitMotion = true;
                }
                else
                {
                        bInitMotion = false;
                }
	}
	else
	{
		ret = ECAT_StopDeviceOpTask(DeviceNo);

		if(ret < 0)
		{
                        str1.sprintf("Failed to stop device op task:%d", ret);
			LogMessage(str1);
			WidgetEnabledByRunMode(DEV_RM_IS_OP_TASK);
		}
		else
		{
			WidgetEnabledByRunMode(DEV_RM_IS_OPEN);
		}


		ret = ECAT_CloseDevice(DeviceNo);
		if(ret < 0)
		{
                        str1.sprintf("Failed to close EcatDevice:%d", ret);
			LogMessage(str1);
			WidgetEnabledByRunMode(DEV_RM_IS_OPEN);
		}
		else
		{
			WidgetEnabledByRunMode(DEV_RM_IS_CLOSE);
		}

                ListView_GroupInfo->Items->Item[0]->SubItems->Strings[2] = "";
                ListView_GroupInfo->Items->Item[1]->SubItems->Strings[2] = "";
                ListView_GroupInfo->Items->Item[2]->SubItems->Strings[2] = "";
                ListView_GroupInfo->Items->Item[3]->SubItems->Strings[2] = "";
	}
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SlaveList_OnItemClick(TObject *Sender)
{
        if(ListView_SlaveInfo->Selected != NULL)
        {
                AnsiString str1;
                char chrData[MAX_PATH];

                int index = ListView_SlaveInfo->Selected->Index;

                str1= ListView_SlaveInfo->Items->Item[index]->Caption;
                strcpy(chrData, str1.c_str());
                SelSlave = atoi(chrData);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_RxPdoGetClick(TObject *Sender)
{
	uint16_t i;
	int32_t ret;
	uint16_t SlaveNo;
	AnsiString StrGetValue;
	uint16_t OffsetByte,DataSize;
	uint8_t Data[RW_PDO_DATA_SIZE_MAX];
	AnsiString str1,comma;
        char chrData[MAX_PATH];

	SlaveNo = SelSlave;

        str1= Edit_RxOffset->Text;
        strcpy(chrData, str1.c_str());
        OffsetByte = (uint16_t)atol(chrData);

        str1= Edit_RxDataSize->Text;
        strcpy(chrData, str1.c_str());
        DataSize = (uint16_t)atol(chrData);

	ret = ECAT_GetSlaveRxPdoData_Ex(DeviceNo,SlaveNo,OffsetByte,DataSize,Data);

	if(ret != 0)
	{
                str1.sprintf("Failed to get RxPdo data:%d",ret);
                LogMessage(str1);
	}
	else
	{
		StrGetValue = "";
		for(i=0;i<DataSize;i++)
		{
                        str1.sprintf("%x",Data[i]);
			if(i!=DataSize-1)comma= ",";
			else comma="";
			StrGetValue = StrGetValue + str1 + comma;
		}
                Edit_RxGetData->Text = StrGetValue;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_RxPdoSetClick(TObject *Sender)
{
	int32_t ret;
	uint16_t SlaveNo;
	uint16_t OffsetByte,DataSize;
	uint8_t Data[RW_PDO_DATA_SIZE_MAX];
	AnsiString str1, str2;
        char chrData[MAX_PATH];

	///////////////////////////////
        str2 = Edit_RxSetData->Text;

        TStringList *sList = new TStringList();
        sList->Delimiter = ','; // ]wnΪr
        sList->DelimitedText = str2;

        int nBytes = sList->Count;
        int str_length=0;

        if (sList->Strings[0] == "")
        {
                LogMessage("set value equal zero");
                return;
        }
        for (int i=0; i<nBytes;i++)
        {
                if(str_length>=RW_PDO_DATA_SIZE_MAX) continue;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList->Strings[i].c_str());
                Data[str_length]= (uint8_t)strtol(chrData,0,16);
                str_length++;
        }
        
	SlaveNo = SelSlave;

	str1= Edit_RxOffset->Text;
        strcpy(chrData, str1.c_str());
        OffsetByte = (uint16_t)atol(chrData);

        str1= Edit_RxDataSize->Text;
        strcpy(chrData, str1.c_str());
        DataSize = (uint16_t)atol(chrData);


	ret = ECAT_GetSlaveRxPdoData_Ex(DeviceNo,SlaveNo,OffsetByte,DataSize,Data);
	if(ret != 0)
	{
                str1.sprintf("Failed to Set RxPdo data:%d",ret);
                LogMessage(str1);
	}
        else
        {
                str1.sprintf("Set Slave_%d RxPdo data (%x) with offset(%d) and size(%d) ", SlaveNo, Data[0], OffsetByte, DataSize);
                LogMessage(str1);
        }

        delete sList;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_TxPdoGetClick(TObject *Sender)
{
        uint16_t i;
	int32_t ret;
	uint16_t SlaveNo;
	AnsiString StrGetValue, str1, comma;
	uint16_t OffsetByte,DataSize;
	uint8_t Data[RW_PDO_DATA_SIZE_MAX];
        char chrData[MAX_PATH];

	SlaveNo = SelSlave;

        str1= Edit_TxOffset->Text;
        strcpy(chrData, str1.c_str());
        OffsetByte = (uint16_t)atol(chrData);

	str1= Edit_TxDataSize->Text;
        strcpy(chrData, str1.c_str());
        DataSize = (uint16_t)atol(chrData);

        ret = ECAT_GetSlaveTxPdoData_Ex(DeviceNo,SlaveNo,OffsetByte,DataSize,Data);
	if(ret != 0)
	{
                str1.sprintf("Failed to Set TxPdo data:%d",ret);
                LogMessage(str1);
	}
	else
	{
		StrGetValue = "";
		for(i=0;i<DataSize;i++)
		{
                        str1.sprintf("%x",Data[i]);
			if(i!=DataSize-1)comma= ",";
			else comma="";
			StrGetValue = StrGetValue + str1 + comma;
		}
		Edit_TxGetData->Text = StrGetValue;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AxisList_OnItemClick(TObject *Sender)
{
        AnsiString str1;
        int index;

        if(ListView_AxisInfo->Selected != NULL)
        {
                char chrData[MAX_PATH];

                index = ListView_AxisInfo->Selected->Index;

                if (ListView_AxisInfo->Items->Item[index]->Checked == true)
                {
                        ListView_AxisInfo->Items->Item[index]->Checked = false;
                        nCheckedAxisCnt--;
                }
                else
                {
                        ListView_AxisInfo->Items->Item[index]->Checked = true;
                        nCheckedAxisCnt++;
                }

                //str1.sprintf("nCheckedAxisCnt:%d", nCheckedAxisCnt);
                //LogMessage(str1);
        }
        else
        {
                POINT pos;
                pos.x = Mouse->CursorPos.x;
                pos.y = Mouse->CursorPos.y;
                ::ScreenToClient(ListView_AxisInfo->Handle,&pos);
                TListItem* Item = ListView_AxisInfo->GetItemAt(pos.x,pos.y);

                if (Item == NULL)
                        return;

                index = Item->Index;
                if (index != nLastCheckAxis)
                {
                        if (ListView_AxisInfo->Items->Item[index]->Checked == true)
                        {
                                nCheckedAxisCnt++;
                                bLastCheckStatus = true;
                        }
                        else
                        {
                                if (nCheckedAxisCnt > 0)
                                        nCheckedAxisCnt--;
                                bLastCheckStatus = false;
                        }
                }
                else
                {
                        if (bLastCheckStatus)
                        {
                                if (nCheckedAxisCnt > 0)
                                        nCheckedAxisCnt--;
                                bLastCheckStatus = false;
                        }
                        else
                        {
                                nCheckedAxisCnt++;
                                bLastCheckStatus = true;
                        }
                }

                //str1.sprintf("nCheckedAxisCnt:%d", nCheckedAxisCnt);
                //LogMessage(str1);

                nLastCheckAxis = index;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ServoOnClick(TObject *Sender)
{
        if (nCheckedAxisCnt == 0)
        {
                LogMessage("No Axis selected!");
                return;
        }
        for (int i = 0; i<AxisCnt; i++)
                if (ListView_AxisInfo->Items->Item[i]->Checked) SetAxisServo(i, 1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ServoOffClick(TObject *Sender)
{
        if (nCheckedAxisCnt == 0)
        {
                LogMessage("No Axis selected!");
                return;
        }
        for (int i = 0; i<AxisCnt; i++)
                if (ListView_AxisInfo->Items->Item[i]->Checked) SetAxisServo(i, 0);
}
//---------------------------------------------------------------------------

void TForm1::SetAxisServo(uint16_t AxisNo, bool OnOff)
{
        int32_t ret;
        AnsiString str1;

        if(AxisNo > MC_AXIS_NO_MAX)
        {
                str1.sprintf("Axis number (%d) exceed MC_AXIS_NO_MAX (%d)",AxisNo, MC_AXIS_NO_MAX);
                LogMessage(str1);
                return;
        }


       	do
	{
		/*
		when error occurred on master or motor driver
		it will take few ms to process error
		in the meantime, ServoOn or ErrorReset will return -1137

		P.S. ServoOn also has the function of clearing errors
		*/
		ret = ECAT_McSetAxisServoOn(DeviceNo,AxisNo,OnOff);
	} while (ret == -1137);

        if(ret < 0)
        {
                if (OnOff)
                        str1.sprintf("Failed to set axis %d servo on:%d",AxisNo, ret);
                else
                        str1.sprintf("Failed to set axis %d servo off:%d",AxisNo, ret);
                LogMessage(str1);
        }
        else
        {
        	uint32_t State, reqState;
                if(OnOff)
                        reqState = MC_AS_STANDSTILL;
                else
                        reqState = MC_AS_DISABLED;

        	for (size_t i = 0; i < 10; i++)
	        {
	        	/*
		        it will take few ms to process ServoOn
	        	when motor driver is ready, axis state should be standstill
		        */
		        ret = ECAT_McGetAxisState_Ex(DeviceNo, AxisNo, &State);
		        if (ret == 0 && State == reqState)
			        break;
	        	Sleep(100);
        	}
	        if (ret != 0 || State != reqState)
	        {
                        if (OnOff)
                                str1.sprintf("Failed to set axis %d servo on:%d",AxisNo, ret);
                        else
                                str1.sprintf("Failed to set axis %d servo off:%d",AxisNo, ret);
                        LogMessage(str1);
	        }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_MoveAbsClick(TObject *Sender)
{
        int32_t ret;
	uint16_t i;
	int32_t argc;

	double Pos[MC_AXIS_NO_MAX];
	double Vel[MC_AXIS_NO_MAX];
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
	memset(Vel,0,sizeof(double)*MC_AXIS_NO_MAX);

        if (CheckBox_ALL->Checked)
        {
                argc = GetAxesMoveData(Pos,Vel);      // get only one data
                if(argc < 0)
                        return;
                for(i=0; i < AxisCnt; i++)
                        SetAxisMoveAbs(i, Pos[0], Vel[0]);
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }

                argc = GetAxesMoveData(Pos,Vel);      // get multiple data
                if(argc < 0)
                        return;
                int iCnt = 0;
                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {
                                if (iCnt < argc)
                                {
                                        SetAxisMoveAbs(i, Pos[iCnt], Vel[iCnt]);
                                        iCnt++;
                                }
                                else
                                        break;
                        }
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_MoveRelClick(TObject *Sender)
{
        int32_t ret;
	uint16_t i;
	int32_t argc;

	double Pos[MC_AXIS_NO_MAX];
	double Vel[MC_AXIS_NO_MAX];
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
	memset(Vel,0,sizeof(double)*MC_AXIS_NO_MAX);

        if (CheckBox_ALL->Checked)
        {
                argc = GetAxesMoveData(Pos,Vel);      // get only one data
                if(argc < 0)
                        return;
                for(i=0; i < AxisCnt; i++)
                        SetAxisMoveRel(i, Pos[0], Vel[0]);
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }
                argc = GetAxesMoveData(Pos,Vel);      // get multiple data
                if(argc < 0)
                        return;
                int iCnt = 0;
                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {
                                if (iCnt < argc)
                                {
                                        SetAxisMoveRel(i, Pos[iCnt], Vel[iCnt]);
                                        iCnt++;
                                }
                                else
                                        break;
                        }
                }
        }
}
//---------------------------------------------------------------------------

int32_t TForm1::GetAxesMoveData(double Pos[],double Vel[])
{
	int32_t argc =1;    // number of position cmd to axes

	AnsiString str1;
        char chrData[MAX_PATH];
        TStringList *sList1 = new TStringList();
        TStringList *sList2 = new TStringList();

        str1 = Edit_Position->Text;
        sList1->Delimiter = ','; // ]wnΪr
        sList1->DelimitedText = str1;

        str1 = Edit_Velocity->Text;
        sList2->Delimiter = ','; // ]wnΪr
        sList2->DelimitedText = str1;

        int nBytes1, nBytes2, str_length;
        nBytes1  = sList1->Count;
        nBytes2  = sList2->Count;

        if (nBytes1 != nBytes2)
        {
                LogMessage("the number of parameters between position and velocity are not equal");
                return -1;
        }

        if (sList1->Strings[0] == "")
        {
                LogMessage("Position list format error! ex:(1,1,1,1)");
                return -1;
        }
        for (int i=0; i<nBytes1;i++)
        {
                if(i>=MC_AXIS_NO_MAX) break;

                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList1->Strings[i].c_str());

                Pos[i] = atof(chrData);
        }
        sList1->Clear();
        delete sList1;

        str_length=0;
        if (sList2->Strings[0] == "")
        {
                LogMessage("Velocity list format error! ex:(1,1,1,1)");
                return -1;
        }
        for (int i=0; i<nBytes2;i++)
        {
                if(str_length>=MC_AXIS_NO_MAX) break;

                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList2->Strings[i].c_str());

                Vel[i] = atof(chrData);
        }
        sList2->Clear();
        delete sList2;

        if(nBytes1 >= MC_AXIS_NO_MAX)
		argc = MC_AXIS_NO_MAX;
	else if(nBytes1 >= AxisCnt)
		argc = AxisCnt;
	else
		argc = nBytes1;

	return argc;
}
//---------------------------------------------------------------------------

void TForm1::SetAxisMoveAbs(uint16_t AxisNo, double Pos, double Vel)
{
        int32_t ret;
        AnsiString str1;

        if(AxisNo > MC_AXIS_NO_MAX)
        {
                str1.sprintf("Axis number (%d) exceed MC_AXIS_NO_MAX (%d)",AxisNo, MC_AXIS_NO_MAX);
                LogMessage(str1);
                return;
        }

        startTime=clock();
        do
        {
                if(timeoutfunc(startTime, "ECAT_McAxisMoveAbs"))break;
                ret = ECAT_McAxisMoveAbs(DeviceNo,AxisNo,Pos,Vel);
        } while (ret!=0);

        if(ret < 0)
        {
                str1.sprintf("Axis[%d] MoveAbs failed:%d",AxisNo, ret);
                LogMessage(str1);
        }
}
//---------------------------------------------------------------------------

void TForm1::SetAxisMoveRel(uint16_t AxisNo, double Pos, double Vel)
{
        int32_t ret;
        AnsiString str1;

        if(AxisNo > MC_AXIS_NO_MAX)
        {
                str1.sprintf("Axis number (%d) exceed MC_AXIS_NO_MAX (%d)",AxisNo, MC_AXIS_NO_MAX);
                LogMessage(str1);
                return;
        }

        startTime=clock();
        do
        {
                if(timeoutfunc(startTime, "ECAT_McAxisMoveAbs"))break;
                ret = ECAT_McAxisMoveRel(DeviceNo,AxisNo,Pos,Vel);
        } while (ret!=0);

        if(ret < 0)
        {
                str1.sprintf("Axis[%d] MoveAbs failed:%d",AxisNo, ret);
                LogMessage(str1);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_MoveJogPClick(TObject *Sender)
{
        int32_t ret;
        uint16_t i;
        AnsiString str1;
        char chrData[MAX_PATH];
        double Vel;

        str1 = Edit_Velocity->Text;
        strcpy(chrData, str1.c_str());
        Vel = fabs(atof(chrData));

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)      SetAxisMoveJog(i, 1, Vel);
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }

                for(i=0; i < AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                                SetAxisMoveJog(i, 1, Vel);
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_MoveJogNClick(TObject *Sender)
{
        int32_t ret;
        uint16_t i;
        AnsiString str1;
        char chrData[MAX_PATH];
        double Vel;

        str1 = Edit_Velocity->Text;
        strcpy(chrData, str1.c_str());
        Vel = fabs(atof(chrData));

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)      SetAxisMoveJog(i, 0, Vel);
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }

                for(i=0; i < AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                                SetAxisMoveJog(i, 0, Vel);
                }
        }
}
//---------------------------------------------------------------------------

void TForm1::SetAxisMoveJog(uint16_t AxisNo, bool Dir, double Vel)
{
        int32_t ret;
        AnsiString str1;

        if(AxisNo > MC_AXIS_NO_MAX)
        {
                str1.sprintf("Axis number (%d) exceed MC_AXIS_NO_MAX (%d)",AxisNo, MC_AXIS_NO_MAX);
                LogMessage(str1);
                return;
        }

        if (Dir)        ret = ECAT_McAxisMoveVel(DeviceNo,AxisNo,Vel);
        else            ret = ECAT_McAxisMoveVel(DeviceNo,AxisNo,-Vel);

        if(ret < 0)
        {
                AnsiString str1;
                if (Dir)        str1.sprintf("Axis[%d] MoveJog+ failed:%d",AxisNo, ret);
                else            str1.sprintf("Axis[%d] MoveJog- failed:%d",AxisNo, ret);
                LogMessage(str1);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_StopClick(TObject *Sender)
{
	int32_t ret;
	uint16_t i;
        AnsiString str1;

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)
                {
                        ret = ECAT_McAxisStop(DeviceNo,i);

                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] stop failed:%d",i, ret);
                                LogMessage(str1);
                        }
                }
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }

                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {
                                ret = ECAT_McAxisStop(DeviceNo,i);

                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] stop failed:%d",i, ret);
                                        LogMessage(str1);
                                }
                        }
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_QuickStopClick(TObject *Sender)
{
        int32_t ret;
	uint16_t i, AxisNo, nStopNum;
        AnsiString str1;

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)
                {
                        startTime=clock();
                        do
                        {		
                                if(timeoutfunc(startTime, "ECAT_McAxisQuickStop"))break;
                                ret = ECAT_McAxisQuickStop(DeviceNo,i);
                        } while (ret!=0);

                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] ResetError failed:%d",i, ret);
                                LogMessage(str1);
                        }
                }
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }
                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {

                        	do
	                        {
		                /*
		                when error occurred on master or motor driver
		                it will take few ms to process error
		                in the meantime, ServoOn or ErrorReset will return -1137

		                P.S. ServoOn also has the function of clearing errors
		                */
                                        ret = ECAT_McAxisErrorReset(DeviceNo, i);
	                        } while (ret == -1137);


                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] ResetError failed:%d",i, ret);
                                        LogMessage(str1);
                                }
                                else
                                {
                                       	uint32_t State;
	                                for (size_t i = 0; i < 10; i++)
	                                {
	                                	/*
		                                it will take few ms to process Error Reset
	                                	when motor driver is ready, axis state should be standstill
	                                	*/
		                                ret = ECAT_McGetAxisState_Ex(DeviceNo, i, &State);
		                                if (ret == 0 && (State == MC_AS_STANDSTILL || State == MC_AS_DISABLED))
			                                break;
		                                Sleep(100);
	                                }
	                                if (ret != 0 || (State != MC_AS_STANDSTILL && State != MC_AS_DISABLED))
	                                {
                                                str1.sprintf("Axis[%d] ResetError failed:%d",i, ret);
                                                LogMessage(str1);
	                                }

                                }
                        }
                }
        }
}
//---------------------------------------------------------------------------

void TForm1::WidgetEnabledByRunMode(device_run_mode_t RunMode)
{
	DevRunMode = RunMode;

	switch(RunMode)
	{
	case DEV_RM_IS_CLOSE: //Device is close
                Button_ScanDev->Enabled = true;
                ComboBox_Dev->Enabled = true;
		Button_Start->Caption = "Start";
                Button_RxPdoGet->Enabled = false;
                Button_RxPdoSet->Enabled = false;
                Button_TxPdoGet->Enabled = false;
                Button_ServoOn->Enabled = false;
                Button_ServoOff->Enabled = false;
                Button_MoveAbs->Enabled = false;
                Button_MoveRel->Enabled = false;
                Button_MoveJogP->Enabled = false;
                Button_MoveJogN->Enabled = false;
                Button_Stop->Enabled = false;
                Button_QuickStop->Enabled = false;
                Edit_ReqState->Text = "";
		SlaveCnt = 0;
		Timer1->Enabled=false;
                bDevOpen = false;
                bStateOP = false;
		break;
	case DEV_RM_IS_OPEN: //Device is open
                Button_ScanDev->Enabled = false;
                ComboBox_Dev->Enabled = false;
		Button_Start->Caption = "Stop";
                Button_RxPdoGet->Enabled = false;
                Button_RxPdoSet->Enabled = false;
                Button_TxPdoGet->Enabled = false;
                Button_ServoOn->Enabled = false;
                Button_ServoOff->Enabled = false;
                Button_MoveAbs->Enabled = false;
                Button_MoveRel->Enabled = false;
                Button_MoveJogP->Enabled = false;
                Button_MoveJogN->Enabled = false;
                Button_Stop->Enabled = false;
                Button_QuickStop->Enabled = false;
		Timer1->Interval = TimerInterval;
                Timer1->Enabled=true;
                bDevOpen = true;
                bStateOP = false;
                bInitMotion = false;
		break;
	case DEV_RM_IS_OP_TASK: //Start op task
		Button_RxPdoGet->Enabled = true;
                Button_RxPdoSet->Enabled = true;
                Button_TxPdoGet->Enabled = true;
                Button_ServoOn->Enabled = true;
                Button_ServoOff->Enabled = true;
                Button_MoveAbs->Enabled = true;
                Button_MoveRel->Enabled = true;
                Button_MoveJogP->Enabled = true;
                Button_MoveJogN->Enabled = true;
                Button_Stop->Enabled = true;
                Button_QuickStop->Enabled = true;
                bStateOP = true;
		break;
	} 

}
//---------------------------------------------------------------------------

AnsiString TForm1::GetGrpStateStr(uint32_t state)
{
	switch(state)
	{
	case MC_GS_DISABLED:
		return "Disabled";
	case MC_GS_STANDBY:
		return "Standby";
	case MC_GS_ERRORSTOP:
		return "ErrorStop";
	case MC_GS_STOPPING:
		return "Stopping";
	case MC_GS_HOMING:
		return "Homing";
	case MC_GS_MOVING:
		return "Moving";
	default:
		return "Invalid";
	}

}
//---------------------------------------------------------------------------

AnsiString TForm1::GetAxisStateStr(uint32_t state)
{
	switch(state)
	{
	case MC_AS_DISABLED:
		return "Disabled";
	case MC_AS_STANDSTILL:
		return "StandStill";
	case MC_AS_ERRORSTOP:
		return "ErrorStop";
	case MC_AS_STOPPING:
		return "Stopping";
	case MC_AS_HOMING:
		return "Homing";
	case MC_AS_DISCRETEMOTION:
		return "DiscMotion";
	case MC_AS_CONTINUOUSMOTION:
		return "ContMotion";
	case MC_AS_SYNCHRONIZEDMOTION:
		return "SyncMotion";
	default:
		return "Invalid";
	}
}

//---------------------------------------------------------------------------

void __fastcall TForm1::GroupList_OnItemClick(TObject *Sender)
{
        if(ListView_GroupInfo->Selected != NULL)
        {
                AnsiString str1;
                char chrData[MAX_PATH];

                int index = ListView_GroupInfo->Selected->Index;

                str1= ListView_GroupInfo->Items->Item[index]->Caption;
                strcpy(chrData, str1.c_str());
                SelGroup = atoi(chrData);
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_AddAllToGroupClick(TObject *Sender)
{
	int32_t ret;
        AnsiString str1, str2;

        if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}

        str2 = "";
	for(int i=0; i < AxisCnt; i++)
        {
                startTime=clock();
                do
                {
                        if(timeoutfunc(startTime, "ECAT_McAddAxisToGroup_Ex"))break;
                        ret = ECAT_McAddAxisToGroup_Ex(DeviceNo, SelGroup, i);
                } while (ret!=0);

                if(ret < 0)
                {
                        str1.sprintf("Failed to add axis %d to group %d:%d", i, SelGroup, ret);
                        LogMessage(str1);
                }
                else
                {
                        if (i == 0)     str1.sprintf("%d", i);
                        else            str1.sprintf(",%d", i);
                        str2 += str1;
                }
	}
        ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2] = str2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_RemoveGroupClick(TObject *Sender)
{
	int32_t ret;
        AnsiString str1, str2;

        if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}


	ret = ECAT_McUngroupAllAxes_Ex(DeviceNo,SelGroup);

	if(ret < 0)
	{
                str1.sprintf("Failed to remove axes from group %d:%d", SelGroup, ret);
                LogMessage(str1);
	}
	else
	{
		ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2] = "";
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_GroupStopClick(TObject *Sender)
{
        int32_t ret;
        AnsiString str1;

	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}


	ret = ECAT_McGroupStop(DeviceNo, SelGroup);

	if(ret < 0)
	{
                str1.sprintf("Group %d Stop failed:%d", SelGroup, ret);
                LogMessage(str1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_GroupQuickStopClick(TObject *Sender)
{
        int32_t ret;
        AnsiString str1;

	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}


	ret = ECAT_McGroupQuickStop(DeviceNo, SelGroup);

	if(ret < 0)
	{
                str1.sprintf("Group %d QuickStop failed:%d", SelGroup, ret);
                LogMessage(str1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_LineAbsClick(TObject *Sender)
{
        int32_t ret;
	double Pos[MC_AXIS_NO_MAX];
	double Vel;
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
        AnsiString str1;

	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}
	if(GetGrpMoveLineData(Pos,Vel) < 0)
		return;


	ret = ECAT_McGroupMoveLineAbs_Ex(DeviceNo, SelGroup, Pos, Vel);

	if(ret < 0)
	{
                str1.sprintf("Group %d MoveLineAbs failed:%d", SelGroup, ret);
                LogMessage(str1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_LineRelClick(TObject *Sender)
{
        int32_t ret;
	double Pos[MC_AXIS_NO_MAX];
	double Vel;
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
        AnsiString str1;

	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}
	if(GetGrpMoveLineData(Pos,Vel) < 0)
		return;


	ret = ECAT_McGroupMoveLineRel_Ex(DeviceNo, SelGroup, Pos, Vel);

	if(ret < 0)
	{
                str1.sprintf("Group %d MoveLineRel failed:%d", SelGroup, ret);
                LogMessage(str1);
	}
}
//---------------------------------------------------------------------------

int32_t TForm1::GetGrpMoveLineData(double Pos[],double &Vel)
{
	AnsiString str1;
        char chrData[MAX_PATH];
        TStringList *sList = new TStringList();

        str1 = Edit_GpLinePos->Text;
        sList->Delimiter = ','; // ]wnΪr
        sList->DelimitedText = str1;

        int nBytes = sList->Count;
        int str_length=0;

        if (sList->Strings[0] == "")
        {
                LogMessage("group line move: position list equal zero");
                return -1;
        }
        for (int i=0; i<nBytes;i++)
        {
                if(str_length>=MC_AXIS_NO_MAX) break;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList->Strings[i].c_str());
                Pos[str_length] = atof(chrData);
                str_length++;
        }
        sList->Clear();

        str1 = Edit_GpLineVel->Text;
        memset(chrData, 0, MAX_PATH);
        strcpy(chrData, str1.c_str());
        Vel = atof(chrData);

	return 0;
}
//---------------------------------------------------------------------------

int32_t TForm1::GetGrpMoveCircData(double Pos1[], double Pos2[], double Pos3[], double &Vel, double &Ang)
{
	AnsiString str1;
        char chrData[MAX_PATH];
        TStringList *sList = new TStringList();
        int nBytes;
        int str_length;

        // pos1
        str1 = Edit_GpCenterPos->Text;
        sList->Delimiter = ','; // ]wnΪr
        sList->DelimitedText = str1;
        nBytes = sList->Count;
        str_length=0;
        if (sList->Strings[0] == "")
        {
                LogMessage("group circlular move: position list equal zero");
                return -1;
        }
        for (int i=0; i<nBytes;i++)
        {
                if(str_length>=MC_AXIS_NO_MAX) break;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList->Strings[i].c_str());
                Pos1[str_length] = atof(chrData);
                str_length++;
        }

        // pos2
        str1 = Edit_GpNvPos->Text;
        sList->Delimiter = ','; // ]wnΪr
        sList->DelimitedText = str1;
        nBytes = sList->Count;
        str_length=0;
        if (sList->Strings[0] == "")
        {
                LogMessage("group circlular move: position list equal zero");
                return -1;
        }
        for (int i=0; i<nBytes;i++)
        {
                if(str_length>=MC_AXIS_NO_MAX) break;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList->Strings[i].c_str());
                Pos2[str_length] = atof(chrData);
                str_length++;
        }

        // pos3
        str1 = Edit_GpEndPos->Text;
        sList->Delimiter = ','; // ]wnΪr
        sList->DelimitedText = str1;
        nBytes = sList->Count;
        str_length=0;
        if (sList->Strings[0] == "")
        {
                LogMessage("group circlular move: position list equal zero");
                return -1;
        }
        for (int i=0; i<nBytes;i++)
        {
                if(str_length>=MC_AXIS_NO_MAX) break;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, sList->Strings[i].c_str());
                Pos3[str_length] = atof(chrData);
                str_length++;
        }
        // end
        sList->Clear();

	str1 = Edit_GpVelocity->Text;
        memset(chrData, 0, MAX_PATH);
        strcpy(chrData, str1.c_str());
        Vel = atof(chrData);

	str1 = Edit_GpAngle->Text;
        memset(chrData, 0, MAX_PATH);
        strcpy(chrData, str1.c_str());
        Ang = atof(chrData);

	return 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_LoopTestClick(TObject *Sender)
{
        int32_t ret;
        //AnsiString str1, str2, str3;
        AnsiString str1, strTemp[4];
        uint16_t GroupNo;

        if (!bLoopRun)
        {
                if (!bInitLoop)
                {
                        if(AxisCnt < 3)
                        {
                                LogMessage("Axis Count error");
                                return;
                        }

                        strTemp[0] = "";
                        strTemp[1] = "";
                        strTemp[2] = "";
                        strTemp[3] = "";

                        double dTemp[360];
                        memset(dTemp, 0, 360*sizeof(double));
                        for (int i=30; i < 90; i++) dTemp[i] = ((double)(i-30)/120.0);
                        for (int i=90; i < 150; i++) dTemp[i] = ((double)(150-i)/120.0);
                        ret = ECAT_McSetEcamTable(DeviceNo, 0, dTemp, 360);
                        if(ret < 0)
                                str1.sprintf("Set Cam Table 0 failed:%d",  ret);
                        else
                                str1.sprintf("Set Cam Table 0 success:%d",  ret);
                        LogMessage(str1);

                        for(int i=0; i < AxisCnt; i++)
                        {
                                if (i < 12)     // group to process 3d move
                                {
                                        GroupNo = floor(i/3);


                                        ret = ECAT_McAddAxisToGroup_Ex(DeviceNo, GroupNo, i);


                                        if(ret < 0)
                                        {
                                                str1.sprintf("Failed to add axis [%d] to group %d:%d", i, GroupNo, ret);
                                                LogMessage(str1);
                                        }
                                        else
                                        {
                                                if ((i%3) == 0)
                                                        str1.sprintf("%d", i);
                                                else
                                                        str1.sprintf(",%d", i);

                                                strTemp[GroupNo] += str1;

                                        }
                                }
                                //else if (i < 24)  // cam in
                                //{
                                //        ret = ECAT_McAxisCamIn(DeviceNo,i-12,i,0,MC_AXIS_SYNC_SOURCE_SET_VALUE, 2);
                                //        if(ret < 0)
                                //        {
                                //                str1.sprintf("Axis [%d] CamIn with Axis [%d] failed:%d", i, i-12,  ret);
                                //                LogMessage(str1);
                                //        }
                                //}
                                //else if (i>=44 && i < AxisCnt)
                                //{
                                //        //ret = ECAT_McAxisGearIn(DeviceNo,AxisCnt-1,i,1,2,MC_AXIS_SYNC_SOURCE_ACTUAL_VALUE);
                                //        ret = ECAT_McAxisGearIn(DeviceNo,i-20,i,1,2,MC_AXIS_SYNC_SOURCE_SET_VALUE);
                                //        if(ret < 0)
                                //        {
                                //                //str1.sprintf("Axis [%d] GearIn with Axis [%d] failed:%d", i, AxisCnt-1, ret);
                                //                str1.sprintf("Axis [%d] GearIn with Axis [%d] failed:%d", i, i-20, ret);
                                //                LogMessage(str1);
	                        //        }
                                //}
                                else    break;
                        }
                        ListView_GroupInfo->Items->Item[0]->SubItems->Strings[2] = strTemp[0];
                        ListView_GroupInfo->Items->Item[1]->SubItems->Strings[2] = strTemp[1];
                        ListView_GroupInfo->Items->Item[2]->SubItems->Strings[2] = strTemp[2];
                        ListView_GroupInfo->Items->Item[3]->SubItems->Strings[2] = strTemp[3];

                        bInitLoop = true;
                }
                ReqLoopCase = 1;
                CurLoopCase = 1;
                bLoopRun = true;
                Button_LoopTest->Caption = "Loop1 Stop";
                Button_LoopTest3D->Enabled = false;
        }
        else
        {
                ReqLoopCase = 101;
                CurLoopCase = 101;
                bLoopRun = false;
                Button_LoopTest->Caption = "Loop1 Start";
                Button_LoopTest3D->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_IOtestClick(TObject *Sender)
{
        int32_t ret;
        AnsiString str1;
        uint32_t ObjectVal = 0;
	uint32_t AbortCode = 0;
        uint16_t SlaveNo = 2;
        uint16_t Index = 0x1c12;
        uint16_t SubIndex = 1;
        uint16_t DataSize = 1;


        //============= sdo test ==============//
        ret = ECAT_GetSlaveSdoObject(DeviceNo, SlaveNo, Index, SubIndex, DataSize,&ObjectVal
		,&AbortCode);
        if (ret == 0)
        {
                str1.sprintf("Get sdo data of 0x%x-%02x :%d", Index, SubIndex, ObjectVal);
                LogMessage(str1);

                Index = (uint16_t)ObjectVal;
                ret = ECAT_GetSlaveSdoObject(DeviceNo, SlaveNo, Index, SubIndex, DataSize,&ObjectVal
		,&AbortCode);
                str1.sprintf("Get sdo data of 0x%x-%02x :%d", Index, SubIndex, ObjectVal);
                LogMessage(str1);

                Index = (uint16_t)((ObjectVal>>16) & 0xffff);
                SubIndex = (uint16_t)(ObjectVal & 0xffff);
                ret = ECAT_GetSlaveSdoObject(DeviceNo, SlaveNo, Index, SubIndex, DataSize,&ObjectVal
		,&AbortCode);
                str1.sprintf("Get sdo data of 0x%x-%02x :%d", Index, SubIndex, ObjectVal);
                LogMessage(str1);
        }
        else
        {
                str1.sprintf("Get sdo data of 0x%x-%02x error :%d", Index, SubIndex, ret);
                LogMessage(str1);
        }

        //============= dio test ==============//
        uint32_t Value = 55;
        ret = ECAT_SetDeviceDO(DeviceNo, Value);
	if(ret == 0)
                str1.sprintf("Set DO value: %d", Value);
        else
                str1.sprintf("Set DO value failed: %d", ret);
        LogMessage(str1);

        ret = ECAT_GetDeviceDO(DeviceNo,&Value);
        if(ret == 0)
                str1.sprintf("Get DO value: %d", Value);
        else
                str1.sprintf("Get DO value failed: %d", ret);
        LogMessage(str1);

        ret = ECAT_GetDeviceDI(DeviceNo,&Value);
         if(ret == 0)
                str1.sprintf("Get DI value: %d", Value);
        else
                str1.sprintf("Get DI value failed: %d", ret);
        LogMessage(str1);


        ret = ECAT_GetDeviceDI(DeviceNo,&ObjectVal);

        if(ret == 0)
                str1.sprintf("Get DI value: %d", ObjectVal);
        else
                str1.sprintf("Get DI value failed: %d", ret);
        LogMessage(str1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox_GpMvModeChange(TObject *Sender)
{
        switch(ComboBox_GpMvMode->ItemIndex)
        {
        case 0: // CircAbs
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 1: // CircAbs_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 2: // CircAbs_CP_EP
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 3: // CircAbs_BP_EP
                Edit_GpCenterPos->Enabled = false;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 4: // 3DCircAbs_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 5: // 3DCircAbs_CP_EP
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 6: // 3DCircAbs_BP_EP
                Edit_GpCenterPos->Enabled = false;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 7: // CircRel
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 8: // CircRel_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 9: // CircRel_CP_EP
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 10: // CircRel_BP_EP
                Edit_GpCenterPos->Enabled = false;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 11: // 3DCircRel_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 12: // 3DCircRel_CP_EP
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 13: // 3DCircRel_BP_EP
                Edit_GpCenterPos->Enabled = false;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = true;
                Edit_GpAngle->Enabled = false;
                Edit_GpPitch->Enabled = false;
                Edit_GpEndRad->Enabled = false;
                break;
        case 14: // HelicAbs
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = false;
                break;
        case 15: // 3DHelicAbs_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = false;
                break;
        case 16: // HelicRel
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = false;
                break;
        case 17: // 3DHelicRel_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = false;
                break;
        case 18: // ConicalHelixAbs
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = true;
                break;
        case 19: // 3DConicalHelixAbs_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = true;
                break;
        case 20: // ConicalHelixRel
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = false;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = true;
                break;
        case 21: // 3DConicalHelixRel_CP_Ang
                Edit_GpCenterPos->Enabled = true;
                Edit_GpNvPos->Enabled = true;
                Edit_GpEndPos->Enabled = false;
                Edit_GpAngle->Enabled = true;
                Edit_GpPitch->Enabled = true;
                Edit_GpEndRad->Enabled = true;
                break;
        default:
                break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_GpStartMoveClick(TObject *Sender)
{
        int32_t ret = 0;
	AnsiString str1, str2;
        char chrData[MAX_PATH];

	double Pos_Ct[MC_AXIS_NO_MAX], Pos_Nv[MC_AXIS_NO_MAX], Pos_Ed[MC_AXIS_NO_MAX];
	double Vel,Ang, Pitch, EndRad;
	memset(Pos_Ct,0,sizeof(double)*MC_AXIS_NO_MAX);
        memset(Pos_Nv,0,sizeof(double)*MC_AXIS_NO_MAX);
        memset(Pos_Ed,0,sizeof(double)*MC_AXIS_NO_MAX);
	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}
	if(GetGrpMoveCircData(Pos_Ct, Pos_Nv, Pos_Ed, Vel, Ang) < 0)
		return;

        strPosX.sprintf("%s, ", ListView_AxisInfo->Items->Item[0]->SubItems->Strings[1]);
        strPosY.sprintf("%s, ", ListView_AxisInfo->Items->Item[1]->SubItems->Strings[1]);
        strPosZ.sprintf("%s, ", ListView_AxisInfo->Items->Item[2]->SubItems->Strings[1]);
                
        switch(ComboBox_GpMvMode->ItemIndex)
        {
        case 0: // CircAbs
                str2 = "MoveCircularAbs";
                str1.sprintf("3DMoveCircularAbs: (%d,%d,%.1f,(%.1f,%.1f,%.1f),%.1f) ", DeviceNo, SelGroup, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Vel);
                LogMessage(str1);

                ret = ECAT_McGroupMoveCircularAbs_Ex(DeviceNo, SelGroup, Ang, Pos_Ct, Vel);

                break;
        case 1: // CircAbs_CP_Ang
                str2 = "MoveCircularAbs_CP_Ang";
                str1.sprintf("MoveCircularAbs_CP_Ang: (%d,%d,%.1f,%.1f,(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2]);
                LogMessage(str1);
                
                ret = ECAT_McGroupMoveCircularAbs_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pos_Ct);
                break;
        case 2: // CircAbs_CP_EP
                str2 = "MoveCircularAbs_CP_EP";
                str1.sprintf("MoveCircularAbs_CP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMoveCircularAbs_CP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Ct, Pos_Ed);
                break;
        case 3: // CircAbs_BP_EP
                str2 = "MoveCircularAbs_BP_EP";
                str1.sprintf("MoveCircularAbs_BP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Nv[0],Pos_Nv[1],Pos_Nv[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);
                startTime=clock();

                ret = ECAT_McGroupMoveCircularAbs_BP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Nv, Pos_Ed);
                break;
        case 4: // 3DCircAbs_CP_Ang
                str2 = "3DMoveCircularAbs_CP_Ang";
                str1.sprintf("3DMoveCircularAbs_CP_Ang: (%d,%d,%.1f,%.1f,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Nv[0],Pos_Nv[1],Pos_Nv[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DCircularAbs_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pos_Ct, Pos_Nv);
                break;
        case 5: // 3DCircAbs_CP_EP
                str2 = "3DMoveCircularAbs_CP_EP";
                str1.sprintf("3DMoveCircularAbs_CP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DCircularAbs_CP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Ct, Pos_Ed);
                break;
        case 6: // 3DCircAbs_BP_EP
                str2 = "3DMoveCircularAbs_BP_EP";
                str1.sprintf("3DMoveCircularAbs_BP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Nv[0],Pos_Nv[1],Pos_Nv[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DCircularAbs_BP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Nv, Pos_Ed);
                break;
        case 7: // CircRel
                str2 = "MoveCircularRel";
                str1.sprintf("3DMoveCircularRel: (%d,%d,%.1f,(%.1f,%.1f,%.1f),%.1f) ", DeviceNo, SelGroup, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Vel);

                ret = ECAT_McGroupMoveCircularRel_Ex(DeviceNo, SelGroup, Ang, Pos_Ct, Vel);
                break;
        case 8: // CircRel_CP_Ang
                str2 = "MoveCircularRel_CP_Ang";
                str1.sprintf("MoveCircularRel_CP_Ang: (%d,%d,%.1f,%.1f,(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMoveCircularRel_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pos_Ct);
                break;
        case 9: // CircRel_CP_EP
                str2 = "MoveCircularRel_CP_EP";
                str1.sprintf("MoveCircularRel_CP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMoveCircularRel_CP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Ct, Pos_Ed);
                break;
        case 10: // CircRel_BP_EP
                str2 = "MoveCircularRel_BP_EP";
                str1.sprintf("MoveCircularRel_BP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Nv[0],Pos_Nv[1],Pos_Nv[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMoveCircularRel_BP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Nv, Pos_Ed);
                break;
        case 11: // 3DCircRel_CP_Ang
                str2 = "3DMoveCircularRel_CP_Ang";
                str1.sprintf("3DMoveCircularRel_CP_Ang: (%d,%d,%.1f,%.1f,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Nv[0],Pos_Nv[1],Pos_Nv[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DCircularRel_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pos_Ct, Pos_Nv);
                break;
        case 12: // 3DCircRel_CP_EP
                str2 = "3DMoveCircularRel_CP_EP";
                str1.sprintf("3DMoveCircularRel_CP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DCircularRel_CP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Ct, Pos_Ed);
                break;
        case 13: // 3DCircRel_BP_EP
                str2 = "3DMoveCircularRel_BP_EP";
                str1.sprintf("3DMoveCircularRel_BP_EP: (%d,%d,%.1f,%d,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, 1, Pos_Nv[0],Pos_Nv[1],Pos_Nv[2], Pos_Ed[0],Pos_Ed[1],Pos_Ed[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DCircularRel_BP_EP_Ex(DeviceNo, SelGroup, Vel, 1, Pos_Nv, Pos_Ed);
                break;
        case 14: // HelicAbs
                str2 = "MoveHelicalAbs";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1.sprintf("MoveHelicalAbs: (%d,%d,%.1f,(%.1f,%.1f,%.1f),%.1f,%.1f) ", DeviceNo, SelGroup, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pitch, Vel);
                LogMessage(str1);

                ret = ECAT_McGroupMoveHelicalAbs_Ex(DeviceNo, SelGroup, Ang, Pos_Ct, Pitch, Vel);
                break;
        case 15: // 3DHelicAbs_CP_Ang
                str2 = "Move3DHelicalAbs_CP_Ang";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1.sprintf("Move3DHelicalAbs_CP_Ang: (%d,%d,%.1f,%.1f,%.1f,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Ang, Vel, Pitch, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Nv[0],Pos_Nv[1],Pos_Nv[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DHelicalAbs_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pitch, Pos_Ct, Pos_Nv);
                break;
        case 16: // HelicRel
                str2 = "MoveHelicalRel";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1.sprintf("MoveHelicalRel: (%d,%d,%.1f,(%.1f,%.1f,%.1f),%.1f,%.1f) ", DeviceNo, SelGroup, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pitch, Vel);
                LogMessage(str1);

                ret = ECAT_McGroupMoveHelicalRel_Ex(DeviceNo, SelGroup, Ang, Pos_Ct, Pitch, Vel);
                break;
        case 17: // 3DHelicRel_CP_Ang
                str2 = "Move3DHelicalRel_CP_Ang";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1.sprintf("Move3DHelicalRel_CP_Ang: (%d,%d,%.1f,%.1f,%.1f,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Ang, Vel, Pitch, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Nv[0],Pos_Nv[1],Pos_Nv[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DHelicalRel_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pitch, Pos_Ct, Pos_Nv);
                break;
        case 18: // ConicalHelixAbs
                str2 = "MoveConicalHelixAbs";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1 = Edit_GpEndRad->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                EndRad = atof(chrData);
                str1.sprintf("MoveConicalHelixAbs: (%d,%d,%.1f,(%.1f,%.1f,%.1f),%.1f,%.1f,%.1f) ", DeviceNo, SelGroup, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pitch, Vel, EndRad);
                LogMessage(str1);

                ret = ECAT_McGroupMoveConicalHelixAbs_Ex(DeviceNo, SelGroup, Ang, Pos_Ct, Pitch, Vel, EndRad);
                break;
        case 19: // 3DConicalHelixAbs_CP_Ang
                str2 = "Move3DConicalHelixAbs_CP_Ang";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1 = Edit_GpEndRad->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                EndRad = atof(chrData);
                str1.sprintf("Move3DConicalHelixAbs_CP_Ang: (%d,%d,%.1f,%.1f,%.1f,%.1f,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Ang, Vel, Pitch, EndRad, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Nv[0],Pos_Nv[1],Pos_Nv[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DConicalHelixAbs_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pitch, Pos_Ct, Pos_Nv, EndRad);
                break;
        case 20: // ConicalHelixRel
                str2 = "MoveConicalHelixRel";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1 = Edit_GpEndRad->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                EndRad = atof(chrData);
                str1.sprintf("MoveConicalHelixRel: (%d,%d,%.1f,(%.1f,%.1f,%.1f),%.1f,%.1f,%.1f) ", DeviceNo, SelGroup, Ang, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pitch, Vel, EndRad);
                LogMessage(str1);

                ret = ECAT_McGroupMoveConicalHelixRel_Ex(DeviceNo, SelGroup, Ang, Pos_Ct, Pitch, Vel, EndRad);
                break;
        case 21: // 3DConicalHelixRel_CP_Ang
                str2 = "Move3DConicalHelixRel_CP_Ang";
                str1 = Edit_GpPitch->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                Pitch = atof(chrData);
                str1 = Edit_GpEndRad->Text;
                memset(chrData, 0, MAX_PATH);
                strcpy(chrData, str1.c_str());
                EndRad = atof(chrData);
                str1.sprintf("Move3DConicalHelixRel_CP_Ang: (%d,%d,%.1f,%.1f,%.1f,%.1f,(%.1f,%.1f,%.1f),(%.1f,%.1f,%.1f)) ", DeviceNo, SelGroup, Vel, Ang, Pitch, EndRad, Pos_Ct[0],Pos_Ct[1],Pos_Ct[2], Pos_Nv[0],Pos_Nv[1],Pos_Nv[2]);
                LogMessage(str1);

                ret = ECAT_McGroupMove3DConicalHelixRel_CP_Angle_Ex(DeviceNo, SelGroup, Vel, Ang, Pitch, Pos_Ct, Pos_Nv, EndRad);
                break;
        default:
                break;
        }

        if(ret < 0)
        {
                str1.sprintf("Group [%d] %s failed:%d", SelGroup, str2, ret);
                LogMessage(str1);
        }
        else
        {
                mRecordCase = 1;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_AddAxisToGroupClick(TObject *Sender)
{
        int32_t ret;
        AnsiString str1, str2;

        if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}
        if (nCheckedAxisCnt == 0)
        {
                LogMessage("No Axis selected!");
                return;
        }
        str2 = "";

        char chrData[MAX_PATH];
        TStringList *sList = new TStringList();
        int nBytes;
        int str_length;

        int nAxisData;
        int nPendAxis = 0;

        str1 = ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2];
        sList->Delimiter = ','; // ]wnΪr
        sList->DelimitedText = str1;
        nBytes = sList->Count;
        str_length=0;

        for (int i=0; i<AxisCnt;i++)
        {
                if (ListView_AxisInfo->Items->Item[i]->Checked)
                {
                        if (str_length >= nBytes)
                        {

                                ret = ECAT_McAddAxisToGroup_Ex(DeviceNo, SelGroup, i);

                                if(ret < 0)
                                {
                                        str1.sprintf("Failed to add axis [%d] to group [%d]:%d", i, SelGroup, ret);
                                        LogMessage(str1);
                                }
                                else
                                {
                                        if (nBytes == 0 && nPendAxis == 0)      str1.sprintf("%d", i);
                                        else                                    str1.sprintf(",%d", i);
                                        str2 += str1;
                                        nPendAxis++;
                                }
                        }
                        else
                        {
                                memset(chrData, 0, MAX_PATH);
                                strcpy(chrData, sList->Strings[str_length].c_str());
                                nAxisData = atoi(chrData);

                                if (nAxisData == i)
                                {
                                        str1.sprintf("Failed to add axis [%d] to group [%d]: duplicated axis no", i, SelGroup);
                                        LogMessage(str1);

                                        if (str_length == 0 && nPendAxis == 0)  str1.sprintf("%d", i);
                                        else                                    str1.sprintf(",%d", i);
                                        str2 += str1;
                                        str_length++;
                                        nPendAxis++;
                                }
                                if (nAxisData > i)
                                {

                                        ret = ECAT_McAddAxisToGroup_Ex(DeviceNo, SelGroup, i);

                                        if(ret < 0)
                                        {
                                                str1.sprintf("Failed to add axis [%d] to group [%d]:%d", i, SelGroup, ret);
                                                LogMessage(str1);
                                        }
                                        else
                                        {
                                                if (nPendAxis == 0)     str1.sprintf("%d", i);
                                                else                    str1.sprintf(",%d", i);
                                                str2 += str1;
                                                nPendAxis++;
                                        }
                                }
                        }

                        if (nPendAxis >= nCheckedAxisCnt)
                                break;
                }
        }
        /*
        if (nBytes > 0)
        {
                for (int i=0; i<nBytes;i++)
                {
                        if(str_length>=MC_AXIS_NO_MAX) break;
                        memset(chrData, 0, MAX_PATH);
                        strcpy(chrData, sList->Strings[i].c_str());
                        nAxisData = atoi(chrData);
                        if (nAxisData == SelAxis)
                        {
                                str1.sprintf("Failed to add axis [%d] to group [%d]: %d, duplicated axis no", SelAxis, SelGroup, ret);
                                LogMessage(str1);
                                str2 = ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2];
                                break;
                        }
                        if (iPending == 0 && nAxisData > SelAxis)
                        {
                                if (i == 0)     str1.sprintf("%d", SelAxis);
                                else            str1.sprintf(",%d", SelAxis);
                                str2 += str1;
                                iPending = 1;
                        }

                        if (i == 0 && iPending == 0)    str1.sprintf("%d", nAxisData);
                        else                            str1.sprintf(",%d", nAxisData);
                        str2 += str1;

                        if (iPending == 0 && i == (nBytes-1))
                        {
                                str1.sprintf(",%d", SelAxis);
                                str2 += str1;
                                iPending = 1;
                        }

                        str_length++;
                }
        }
        else
        {
                str1.sprintf("%d", SelAxis);
                str2 += str1;
        }*/
        sList->Clear();
        delete sList;

        ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2] = str2;



        /*
        ret = ECAT_McAddAxisToGroup_Ex(DeviceNo, SelGroup, SelAxis);

        if(ret < 0)
        {
                str1.sprintf("Failed to add axis [%d] to group [%d]:%d", SelAxis, SelGroup, ret);
                LogMessage(str1);
        }
        else
        {
                char chrData[MAX_PATH];
                TStringList *sList = new TStringList();
                int nBytes;
                int str_length;
                int iPending = 0;
                int nAxisData;

                str1 = ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2];
                sList->Delimiter = ','; // ]wnΪr
                sList->DelimitedText = str1;
                nBytes = sList->Count;
                str_length=0;

                if (nBytes > 0)
                {
                        for (int i=0; i<nBytes;i++)
                        {
                                if(str_length>=MC_AXIS_NO_MAX) break;
                                memset(chrData, 0, MAX_PATH);
                                strcpy(chrData, sList->Strings[i].c_str());
                                nAxisData = atoi(chrData);
                                if (nAxisData == SelAxis)
                                {
                                        str1.sprintf("Failed to add axis [%d] to group [%d]: %d, duplicated axis no", SelAxis, SelGroup, ret);
                                        LogMessage(str1);
                                        str2 = ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2];
                                        break;
                                }
                                if (iPending == 0 && nAxisData > SelAxis)
                                {
                                        if (i == 0)     str1.sprintf("%d", SelAxis);
                                        else            str1.sprintf(",%d", SelAxis);
                                        str2 += str1;
                                        iPending = 1;
                                }

                                if (i == 0 && iPending == 0)    str1.sprintf("%d", nAxisData);
                                else                            str1.sprintf(",%d", nAxisData);
                                str2 += str1;

                                if (iPending == 0 && i == (nBytes-1))
                                {
                                        str1.sprintf(",%d", SelAxis);
                                        str2 += str1;
                                        iPending = 1;
                                }

                                str_length++;
                        }
                }
                else
                {
                        str1.sprintf("%d", SelAxis);
                        str2 += str1;
                }
                sList->Clear();
                ListView_GroupInfo->Items->Item[SelGroup]->SubItems->Strings[2] = str2;
        }*/

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox_ALLClick(TObject *Sender)
{
        if (CheckBox_ALL->Checked)
        {
                for (int i = 0; i<AxisCnt; i++) ListView_AxisInfo->Items->Item[i]->Checked = true;
                nCheckedAxisCnt = AxisCnt;
        }
        else
        {
                for (int i = 0; i<AxisCnt; i++) ListView_AxisInfo->Items->Item[i]->Checked = false;
                nCheckedAxisCnt = 0;
        }

        ListView_AxisInfo->Selected = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_LoopTest3DClick(TObject *Sender)
{
        int32_t ret;
        AnsiString str1, strTemp[4];
        uint16_t GroupNo;

        if (!bLoopRun)
        {
                if (!bInitLoop)
                {
                        if(AxisCnt < 4)
                        {
                                LogMessage("Axis Count error");
                                return;
                        }

                        strTemp[0] = "";
                        strTemp[1] = "";
                        strTemp[2] = "";
                        strTemp[3] = "";

                        double dTemp[360];
                        memset(dTemp, 0, 360*sizeof(double));
                        for (int i=30; i < 90; i++) dTemp[i] = ((double)(i-30)/120.0);
                        for (int i=90; i < 150; i++) dTemp[i] = ((double)(150-i)/120.0);
                        ret = ECAT_McSetEcamTable(DeviceNo, 0, dTemp, 360);
                        if(ret < 0)
                                str1.sprintf("Set Cam Table 0 failed:%d",  ret);
                        else
                                str1.sprintf("Set Cam Table 0 success:%d",  ret);
                        LogMessage(str1);

                        for(int i=0; i < AxisCnt; i++)
                        {
                                if (i < 12)     // group to process 3d move
                                {
                                        GroupNo = floor(i/3);

                                        ret = ECAT_McAddAxisToGroup_Ex(DeviceNo, GroupNo, i);

                                        if(ret < 0)
                                        {
                                                str1.sprintf("Failed to add axis [%d] to group %d:%d", i, GroupNo, ret);
                                                LogMessage(str1);
                                        }
                                        else
                                        {
                                                if ((i%4) == 0)
                                                        str1.sprintf("%d", i);
                                                else
                                                        str1.sprintf(",%d", i);

                                                strTemp[GroupNo] += str1;

                                        }
                                }
                                //else if (i < 24)  // cam in
                                //{
                                //        ret = ECAT_McAxisCamIn(DeviceNo,i-12,i,0,MC_AXIS_SYNC_SOURCE_SET_VALUE, 2);
                                //        if(ret < 0)
                                //        {
                                //                str1.sprintf("Axis [%d] CamIn with Axis [%d] failed:%d", i, i-12,  ret);
                                //                LogMessage(str1);
                                //        }
                                //}
                                //else if (i>=44 && i < AxisCnt)
                                //{
                                //        //ret = ECAT_McAxisGearIn(DeviceNo,AxisCnt-1,i,1,2,MC_AXIS_SYNC_SOURCE_ACTUAL_VALUE);
                                //        ret = ECAT_McAxisGearIn(DeviceNo,i-20,i,1,2,MC_AXIS_SYNC_SOURCE_SET_VALUE);
                                //        if(ret < 0)
                                //        {
                                //                //str1.sprintf("Axis [%d] GearIn with Axis [%d] failed:%d", i, AxisCnt-1, ret);
                                //                str1.sprintf("Axis [%d] GearIn with Axis [%d] failed:%d", i, i-20, ret);
                                //                LogMessage(str1);
	                        //        }
                                //}
                                else    break;
                        }
                        ListView_GroupInfo->Items->Item[0]->SubItems->Strings[2] = strTemp[0];
                        ListView_GroupInfo->Items->Item[1]->SubItems->Strings[2] = strTemp[1];
                        ListView_GroupInfo->Items->Item[2]->SubItems->Strings[2] = strTemp[2];
                        ListView_GroupInfo->Items->Item[3]->SubItems->Strings[2] = strTemp[3];

                        bInitLoop = true;
                }
                ReqLoopCase = 11;
                CurLoopCase = 11;
                bLoopRun = true;
                Button_LoopTest3D->Caption = "Loop2 Stop";
                Button_LoopTest->Enabled = false;
        }
        else
        {
                ReqLoopCase = 101;
                CurLoopCase = 101;
                bLoopRun = false;
                Button_LoopTest3D->Caption = "Loop2 Start";
                Button_LoopTest->Enabled = true;
        }        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_LineAbsPTClick(TObject *Sender)
{
        int32_t ret;
	double Pos[MC_AXIS_NO_MAX];
	double Vel, Time;
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
        AnsiString str1;
        char chrData[MAX_PATH];

	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}
	if(GetGrpMoveLineData(Pos,Vel) < 0)
		return;

        str1 = Edit_GpLineTime->Text;
        memset(chrData, 0, MAX_PATH);
        strcpy(chrData, str1.c_str());
        Time = atof(chrData);


	ret = ECAT_McGroupMoveLineAbs_PT_Ex(DeviceNo, SelGroup, Pos, Time);

	if(ret < 0)
	{
                str1.sprintf("Group %d MoveLineAbsPT failed:%d", SelGroup, ret);
                LogMessage(str1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_LineRelPTClick(TObject *Sender)
{
        int32_t ret;
	double Pos[MC_AXIS_NO_MAX], Vel[MC_AXIS_NO_MAX];
	//double Vel, Time;
        double Time;
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
        AnsiString str1;
        char chrData[MAX_PATH];

	if(SelGroup >MC_GROUP_NO_MAX)
	{
                LogMessage("Group No. error");
		return;
	}
	if(GetGrpMoveLineData(Pos,Vel[0]) < 0)
		return;

        str1 = Edit_GpLineTime->Text;
        memset(chrData, 0, MAX_PATH);
        strcpy(chrData, str1.c_str());
        Time = atof(chrData);


	//ret = ECAT_McGroupMoveLineRel_PT(DeviceNo, SelGroup, Pos, Time);
        ret = ECAT_McGroupMoveLineRel_PVT(DeviceNo, SelGroup, Pos, Vel, Time);
	if(ret < 0)
	{
                str1.sprintf("Group %d MoveLineRelPT failed:%d", SelGroup, ret);
                LogMessage(str1);
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_ErrResetClick(TObject *Sender)
{
        int32_t ret;
	uint16_t i;
        AnsiString str1;

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)
                {
                        ret = ECAT_McAxisErrorReset(DeviceNo, i);

                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] ResetError failed:%d",i, ret);
                                LogMessage(str1);
                        }
                }
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }
                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {

                                ret = ECAT_McAxisErrorReset(DeviceNo, i);
                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] ResetError failed:%d",i, ret);
                                        LogMessage(str1);
                                }
                        }
                }
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_StartHomeClick(TObject *Sender)
{
	int32_t ret, Method;
        uint16_t i;
        AnsiString str1;
        char chrData[MAX_PATH];

        str1= Edit_HomeMethod->Text;
        strcpy(chrData, str1.c_str());
        Method = (int32_t)atol(chrData);

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)
                {

                        ret = ECAT_McSetAxisHomeMethod(DeviceNo, i, Method);
                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] Set Home method failed:%d",i, ret);
                                LogMessage(str1);
                        }


                        ret = ECAT_McAxisHome(DeviceNo, i);
                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] Homing failed:%d",i, ret);
                                LogMessage(str1);
                        }
                }
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }

                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {

                                ret = ECAT_McSetAxisHomeMethod(DeviceNo, i, Method);
                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] Set Home method failed:%d",i, ret);
                                        LogMessage(str1);
                                }


                                ret = ECAT_McAxisHome(DeviceNo, i);
                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] Homing failed:%d",i, ret);
                                        LogMessage(str1);
                                }
                        }
                }
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_LineAbsPVTClick(TObject *Sender)
{
        /*int32_t ret;
	double Pos[MC_AXIS_NO_MAX];
	//double Vel;
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
        AnsiString str1, str2, str3;
        int16_t DataSize = 15;


        for (int i = 0; i < DataSize; i++)
        {
              Pos[i] = i*0.1;
        }


	ret = ECAT_McSetProfileData(DeviceNo,  0, Pos, DataSize);


	if(ret < 0)
	{
                str1.sprintf("Profile0 SetProfileData failed:%d", ret);
                LogMessage(str1);
	}
        else
        {
                str2 = "";
                for (int i = 0; i < DataSize; i++)
                {
                      str3.sprintf("%.03f, ", Pos[i]);
                      str2 += str3;
                }
                str1.sprintf("Profile0 SetProfileData success:%s", str2);
                LogMessage(str1);
        } */



        int32_t ret;
	AnsiString str1;
        char chrData[MAX_PATH];

        int iFileHandle;
        int iFileLength;
        int iBytesRead;
        int iByteRemain;
        char *pszBuffer;
        char SlaveName[MAX_PATH];

        uint16_t ProfileNo = 0;     // set 0 as default in this demo
	uint32_t Offset = 0;
       	uint8_t LastFlag;


        //============ Step2: Config network =============//
        AnsiString FileName = "Profile1.csv";
        iFileHandle = FileOpen(FileName, fmOpenRead);

        if (iFileHandle > 0)
        {
            iFileLength = FileSeek(iFileHandle,0,2);
            FileSeek(iFileHandle,0,0);
            pszBuffer = new char[iFileLength+1];
            iBytesRead = FileRead(iFileHandle, pszBuffer, iFileLength);
            FileClose(iFileHandle);

            str1.sprintf("File size: %d Byte", iBytesRead);
            LogMessage(str1);

            int iByteIndex = 0;
            int iReadSize;

            while (iByteIndex < iBytesRead)
            {
                if ((iByteIndex+ECAT_IPC_DATA_SIZE_MAX) < iBytesRead)
                {
                  iReadSize = ECAT_IPC_DATA_SIZE_MAX;
                  LastFlag = false;
                }
                else
                {
                  iReadSize = iBytesRead -  iByteIndex;
                  LastFlag = true;
                }

                if((ret = ECAT_McSetProfileCSV(DeviceNo,ProfileNo,Offset,&pszBuffer[Offset],iReadSize,LastFlag)) < 0)
                {
                      str1.sprintf("Failed to Set Profile data :%d (%d)", ret, Offset);
                      LogMessage(str1);
                }
                else
                {
                        str1 = pszBuffer;
                        LogMessage(str1);
                        if (LastFlag)
                                LogMessage("Set Profile data (CSV) finished");
                }
                iByteIndex += iReadSize;
                Offset += iReadSize;
            }
            delete [] pszBuffer;
        }
        else
        {
                 str1.sprintf("File open error  (%s)", FileName);
                 LogMessage(str1);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_LineRelPVTClick(TObject *Sender)
{
        int32_t ret;
	double Pos[MC_AXIS_NO_MAX];
	//double Vel;
	memset(Pos,0,sizeof(double)*MC_AXIS_NO_MAX);
        AnsiString str1, str2, str3;
        uint16_t ProfileNo = 0;     // set 0 as default in this demo
        int16_t DataSize = 15;


	ret = ECAT_McGetProfileData(DeviceNo,  ProfileNo, Pos, DataSize);

	if(ret < 0)
	{
                str1.sprintf("Profile0 McGetProfileData failed:%d", ret);
                LogMessage(str1);
	}
        else
        {
                str2 = "";
                for (int i = 0; i < DataSize; i++)
                {
                      str3.sprintf("%.03f, ", Pos[i]);
                      str2 += str3;
                }
                str1.sprintf("Profile0 McGetProfileData success:%s", str2);
                LogMessage(str1);
        }

        //ECAT_McAxisMoveProfile(DeviceNo,  1, 0, DataSize);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_SetSoftLimitClick(TObject *Sender)
{
        int32_t ret;
	uint16_t i;
        AnsiString str1;

        double Maximum = 100.0;
        double Minimum = -100.0;

        if (CheckBox_ALL->Checked)
        {
                for(i=0; i < AxisCnt; i++)
                {

                        ret = ECAT_McSetAxisPosSoftwareLimitStatus(DeviceNo, i, 1, 0);

                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] set SoftwareLimitStatus failed:%d",i, ret);
                                LogMessage(str1);
                        }



                        ret = ECAT_McSetAxisPosSoftwareLimit(DeviceNo, i, Maximum, Minimum);

                        if(ret < 0)
                        {
                                str1.sprintf("Axis[%d] set PosSoftwareLimit failed:%d",i, ret);
                                LogMessage(str1);
                        }
                }
        }
        else
        {
                if (nCheckedAxisCnt == 0)
                {
                        LogMessage("No Axis selected!");
                        return;
                }

                for (int i = 0; i<AxisCnt; i++)
                {
                        if (ListView_AxisInfo->Items->Item[i]->Checked)
                        {

                                ret = ECAT_McSetAxisPosSoftwareLimitStatus(DeviceNo, i, 1, 0);

                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] set SoftwareLimitStatus failed:%d",i, ret);
                                        LogMessage(str1);
                                }



                                ret = ECAT_McSetAxisPosSoftwareLimit(DeviceNo, i, Maximum, Minimum);

                                if(ret < 0)
                                {
                                        str1.sprintf("Axis[%d] set PosSoftwareLimit failed:%d",i, ret);
                                        LogMessage(str1);
                                }
                        }
                }
        }
}
//---------------------------------------------------------------------------

