//---------------------------------------------------------------------------

#ifndef Unit_EcatDemoH
#define Unit_EcatDemoH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <time.h>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
#define DEV_TIMER_CYCLE_TIME 20 //ms
#define timeout 10//ms
#define timeout_OP 30000//ms
#define StartOP_RetryTimes      100
#define FILE_BUF_SIZE_MAX 2048
#define ECAT_IPC_DATA_SIZE_MAX 512
#define WIDGET_SLAVE_DIO_DATA_SIZE 32

#define TimerInterval   100
//---------------------------------------------------------------------------

/** EcaDevice Axis Parameter
 */
typedef struct ecat_axis_init_param{
	uint16_t 			SlaveNo[MC_AXIS_NO_MAX];
	uint16_t			SubAxisNo[MC_AXIS_NO_MAX];
	double   			PPU[MC_AXIS_NO_MAX];
	int32_t 			HomeMethod[MC_AXIS_NO_MAX];
	double              HomeSpeedSeachSw[MC_AXIS_NO_MAX];
	double              HomeSpeedSeachZr[MC_AXIS_NO_MAX];
	double 				HomeAcc[MC_AXIS_NO_MAX];
	uint32_t            EncoderPPR[MC_AXIS_NO_MAX];
	uint32_t            MotorPPR[MC_AXIS_NO_MAX];
	uint16_t            AxisAccTime[MC_AXIS_NO_MAX];
	uint16_t            AxisAccDecType[MC_AXIS_NO_MAX];
}ecat_axis_init_param_t;
/*****************************************************************************/
typedef struct ecat_mc_group_param{
        uint16_t            CmdMode;
        uint16_t            AccTime;
}ecat_mc_group_param_t;
/*****************************************************************************/
typedef struct axis_di{
    union
    {
        struct
        {
            uint8_t	NOT		: 1;		//Negative limit switch
            uint8_t	POT		: 1;		//Positive limit switch
            uint8_t	ORG		: 1;		//home switch
            uint8_t	ALM		: 1;		//alarm
            uint8_t	WAN		: 1;		//warning
            uint8_t	SVN		: 1;		//serve on status
            uint8_t	VIR		: 1;		//virtual axis
            uint32_t	reserved : 25;	//Reserved(bit3~bit31)
        };
        uint32_t DIs;
    };
}axis_di_t;
/*****************************************************************************/

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TButton *Button_ScanDev;
        TComboBox *ComboBox_Dev;
        TListBox *ListBox_LogMsg;
        TTimer *Timer1;
        TButton *Button_Start;
        TGroupBox *GroupBox2;
        TGroupBox *GroupBox_SlaveInfo;
        TListView *ListView_SlaveInfo;
        TGroupBox *GroupBox_RxPDO;
        TLabel *Label1;
        TLabel *Label2;
        TEdit *Edit_RxOffset;
        TEdit *Edit_RxDataSize;
        TEdit *Edit_RxGetData;
        TEdit *Edit_RxSetData;
        TButton *Button_RxPdoGet;
        TButton *Button_RxPdoSet;
        TGroupBox *GroupBox_TxPDO;
        TLabel *Label4;
        TLabel *Label5;
        TEdit *Edit_TxOffset;
        TEdit *Edit_TxDataSize;
        TButton *Button_TxPdoGet;
        TEdit *Edit_TxGetData;
        TListView *ListView_AxisInfo;
        TButton *Button_ServoOn;
        TButton *Button_ServoOff;
        TCheckBox *CheckBox_ALL;
        TButton *Button_MoveAbs;
        TButton *Button_MoveRel;
        TButton *Button_Stop;
        TLabel *Label3;
        TLabel *Label6;
        TEdit *Edit_Velocity;
        TEdit *Edit_Position;
        TButton *Button_QuickStop;
        TButton *Button_MoveJogP;
        TButton *Button_MoveJogN;
        TEdit *Edit_ReqState;
        TEdit *Edit_SlavesResp;
        TEdit *Edit_Wc;
        TGroupBox *GroupBox1;
        TListView *ListView_GroupInfo;
        TButton *Button_AddAllToGroup;
        TButton *Button_RemoveGroup;
        TButton *Button_GroupStop;
        TGroupBox *GroupBox3;
        TLabel *Label7;
        TEdit *Edit_GpLineVel;
        TLabel *Label8;
        TEdit *Edit_GpLinePos;
        TButton *Button_LineAbs;
        TButton *Button_LineRel;
        TGroupBox *GroupBox4;
        TEdit *Edit_GpCenterPos;
        TEdit *Edit_GpAngle;
        TEdit *Edit_GpPitch;
        TButton *Button_GroupQuickStop;
        TEdit *Edit_GpVelocity;
        TLabel *Label9;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TButton *Button_LoopTest;
        TButton *Button_IOtest;
        TLabel *Label13;
        TLabel *Label14;
        TEdit *Edit_GpNvPos;
        TEdit *Edit_GpEndPos;
        TComboBox *ComboBox_GpMvMode;
        TButton *Button_GpStartMove;
        TButton *Button_AddAxisToGroup;
        TButton *Button_LoopTest3D;
        TLabel *Label15;
        TEdit *Edit_GpLineTime;
        TButton *Button_LineAbsPT;
        TButton *Button_LineRelPT;
        TButton *Button_ErrReset;
        TLabel *Label16;
        TEdit *Edit_HomeMethod;
        TButton *Button_StartHome;
        TLabel *Label17;
        TEdit *Edit_GpEndRad;
        TButton *Button_LineRelPVT;
        TButton *Button_LineAbsPVT;
        TLabel *Label18;
        TLabel *Label19;
        TEdit *Edit_SoftLimitMax;
        TLabel *Label20;
        TEdit *Edit_SoftLimitMin;
        TButton *Button_SetSoftLimit;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Button_ScanDevClick(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall Button_StartClick(TObject *Sender);
        void __fastcall SlaveList_OnItemClick(TObject *Sender);
        void __fastcall Button_RxPdoGetClick(TObject *Sender);
        void __fastcall Button_RxPdoSetClick(TObject *Sender);
        void __fastcall Button_TxPdoGetClick(TObject *Sender);
        void __fastcall AxisList_OnItemClick(TObject *Sender);
        void __fastcall Button_ServoOnClick(TObject *Sender);
        void __fastcall Button_ServoOffClick(TObject *Sender);
        void __fastcall Button_MoveAbsClick(TObject *Sender);
        void __fastcall Button_MoveRelClick(TObject *Sender);
        void __fastcall Button_MoveJogPClick(TObject *Sender);
        void __fastcall Button_MoveJogNClick(TObject *Sender);
        void __fastcall Button_StopClick(TObject *Sender);
        void __fastcall Button_QuickStopClick(TObject *Sender);
        void __fastcall GroupList_OnItemClick(TObject *Sender);
        void __fastcall Button_AddAllToGroupClick(TObject *Sender);
        void __fastcall Button_RemoveGroupClick(TObject *Sender);
        void __fastcall Button_GroupStopClick(TObject *Sender);
        void __fastcall Button_GroupQuickStopClick(TObject *Sender);
        void __fastcall Button_LineAbsClick(TObject *Sender);
        void __fastcall Button_LineRelClick(TObject *Sender);
        void __fastcall Button_LoopTestClick(TObject *Sender);
        void __fastcall Button_IOtestClick(TObject *Sender);
        void __fastcall ComboBox_GpMvModeChange(TObject *Sender);
        void __fastcall Button_GpStartMoveClick(TObject *Sender);
        void __fastcall Button_AddAxisToGroupClick(TObject *Sender);
        void __fastcall CheckBox_ALLClick(TObject *Sender);
        void __fastcall Button_LoopTest3DClick(TObject *Sender);
        void __fastcall Button_LineAbsPTClick(TObject *Sender);
        void __fastcall Button_LineRelPTClick(TObject *Sender);
        void __fastcall Button_ErrResetClick(TObject *Sender);
        void __fastcall Button_StartHomeClick(TObject *Sender);
        void __fastcall Button_LineAbsPVTClick(TObject *Sender);
        void __fastcall Button_LineRelPVTClick(TObject *Sender);
        void __fastcall Button_SetSoftLimitClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        __fastcall ~TForm1();
        uint16_t DeviceNo;
        uint16_t SelSlave;
        //uint16_t SelAxis;
        uint16_t SelGroup;
        bool emergencystop;
        bool bDevOpen;
        bool bStateOP;
        bool bInitMotion;
        bool bInitLoop;
        bool bLoopRun;
        uint16_t ReqLoopCase;
        uint16_t CurLoopCase;
        uint16_t LoopWaitCnt;
        uint32_t SlaveCnt;
        uint16_t AxisCnt;
        uint16_t nLastCheckAxis;
        bool     bLastCheckStatus;
        uint16_t nCheckedAxisCnt;
        clock_t startTime;

        int mRecordCase;
        AnsiString strPosX, strPosY, strPosZ;

        uint8_t DoData[WIDGET_SLAVE_DIO_DATA_SIZE];
	uint8_t DiData[WIDGET_SLAVE_DIO_DATA_SIZE];
	uint16_t DoBitSize,DoByteSize;
	uint16_t DiBitSize,DiByteSize;

        bool rxbitstate[64];
	bool enablerx[64];
	bool txbitstate[64];
	bool enabletx[64];

        typedef enum {
		DEV_RM_IS_CLOSE = 0,
		DEV_RM_IS_OPEN,
		DEV_RM_IS_OP_TASK,
	}device_run_mode_t;

        device_run_mode_t DevRunMode;
	ecat_axis_init_param_t AxisInitParam;

        bool timeoutfunc(clock_t startTime, AnsiString strMsg);
        void LogMessage(AnsiString strMsg);
        int32_t SetAxisParam(uint16_t AxisNo);
        void SetAxisServo(uint16_t AxisNo, bool OnOff);
        void WidgetEnabledByRunMode(device_run_mode_t RunMode);
        int32_t GetAxesMoveData(double Pos[],double Vel[]);
        void SetAxisMoveAbs(uint16_t AxisNo, double Pos, double Vel);
        void SetAxisMoveRel(uint16_t AxisNo, double Pos, double Vel);
        void SetAxisMoveJog(uint16_t AxisNo, bool Dir, double Vel);
        int32_t GetGrpMoveLineData(double Pos[], double &Vel);
        int32_t GetGrpMoveCircData(double Pos1[], double Pos2[], double Pos3[], double &Vel, double &Ang);
        AnsiString GetGrpStateStr(uint32_t state);
        AnsiString GetAxisStateStr(uint32_t state);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
